<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
   exclude-result-prefixes="xpil str"
   xmlns:xpil="http://www.together.at/2006/XPIL1.0"
   version="1.0"
   xmlns:prop="java.util.Properties"
   xmlns:str="http://exslt.org/strings"
   extension-element-prefixes="str">
   <xsl:output method="xhtml"/>
   <xsl:param name="username" select="u"/>
   <xsl:param name="from_element" select="11"/>
   <xsl:param name="sharkEdition" select="e" />
   <xsl:param name="category" select="e" />
   <xsl:param name="protocol" select="e" />
   <xsl:param name="host" select="e" />
   <xsl:param name="port" select="e" />
   <xsl:param name="edmWebDAVAllowed" select="e" />
   <xsl:param name="sessionKey" select="e" />
   <xsl:param name="isWebDAVVisible" select="e" />
   	<xsl:include xmlns:xsl="http://www.w3.org/1999/XSL/Transform" href="footer.xsl" />
	<xsl:include xmlns:xsl="http://www.w3.org/1999/XSL/Transform" href="properties.xsl"/>
   
   <xsl:template match="xpil:ExtendedWorkflowFacilityInstance">
      <html xmlns:xforms="http://www.w3.org/2002/xforms" xmlns:ev="http://www.w3.org/2001/xml-events" xmlns="http://www.w3.org/1999/xhtml" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xpdl="http://www.wfmc.org/2002/XPDL1.0" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xpil="http://www.together.at/2006/XPIL1.0">
      <head>
				<title>Activity Details</title>
				<link href="styles/style.css" rel="stylesheet" type="text/css" media="screen,projection,tv"/>
				<link href="styles/style_ie.css" rel="stylesheet" type="text/css" media="screen,projection,tv"/>
				
				<!--[if lte IE 6]>
				<link href="styles/style_iel.css" rel="stylesheet" type="text/css" media="screen,projection,tv">
				<![endif]-->
				<!--[if gte IE 7]>
				<link href="styles/style_ie.css" rel="stylesheet" type="text/css" media="screen,projection,tv">
				<![endif]-->
				<!--[if gte IE 8]>
				<link href="styles/style_ien.css" rel="stylesheet" type="text/css" media="screen,projection,tv">
				<![endif]-->
				<script type="text/javascript" src="js/jslib.js"></script>
				<script type="text/javascript" src="js/dynstyles.js"></script>
				
            <xforms:model id="firstForm">
               <xforms:submission id="complete" action="ActivityHandlerPO.po?event=complete&#38;from={$from_element}&#38;category={$category}" method="post" replace="all"/>
               <xforms:submission id="update" action="ActivityHandlerPO.po?event=update&#38;from={$from_element}&#38;category={$category}" method="post" replace="all"/>
               <xforms:submission id="close" action="ActivityHandlerPO.po?event=close&#38;from={$from_element}&#38;category={$category}" method="post" replace="all"/>
               <!--<xforms:submission id="continue" action="../jsp/debug-instance.jsp?f=Complete" method="post" replace="all" />-->
               <xforms:instance id="firstInstance">
                  <xsl:copy-of select="."/>
               </xforms:instance>
               <xsl:variable name="vext" select="prop:setProperty('variablesExist','false')"/>
               <xsl:for-each select="xpil:StringDataInstance">
                  <xsl:variable name="vext" select="prop:setProperty('variablesExist','true')"/>
                  <xsl:variable name="i">
                     <xsl:value-of select="@Id"/>
                  </xsl:variable>
                  <xsl:variable name="suff">
                     <xsl:value-of select="xpdl:DataField/@Name"/>
                  </xsl:variable>
                  <xsl:variable name="req">
                     <xsl:value-of select="xpdl:DataField/xpdl:ExtendedAttributes/xpdl:ExtendedAttribute[@Name='is_mandatory']/@Value"/>
                  </xsl:variable>
                   <xsl:variable name="con">
                     <xsl:value-of select="xpdl:DataField/xpdl:ExtendedAttributes/xpdl:ExtendedAttribute[@Name='max_length']/@Value"/>
                  </xsl:variable>
                  <xsl:variable name="isuff">
                     <xsl:value-of select="concat($i,'#',$suff)"/>
                  </xsl:variable>
                  <xforms:bind id="{$isuff}" nodeset="*/@Value[../@Id='{$i}']" type="string" required="{$req}" constraint="{$con}"/>
               </xsl:for-each>
               <xsl:for-each select="xpil:DoubleDataInstance">
                  <xsl:variable name="vext" select="prop:setProperty('variablesExist','true')"/>
                  <xsl:variable name="i">
                     <xsl:value-of select="@Id"/>
                  </xsl:variable>
                  <xsl:variable name="suff">
                     <xsl:value-of select="xpdl:DataField/@Name"/>
                  </xsl:variable>
                  <xsl:variable name="isuff">
                     <xsl:value-of select="concat($i,'#',$suff)"/>
                  </xsl:variable>
                  <xforms:bind id="{$isuff}" nodeset="*/@Value[../@Id='{$i}']" type="double"/>
               </xsl:for-each>
               <xsl:for-each select="xpil:LongDataInstance">
                  <xsl:variable name="vext" select="prop:setProperty('variablesExist','true')"/>
                  <xsl:variable name="i">
                     <xsl:value-of select="@Id"/>
                  </xsl:variable>
                  <xsl:variable name="suff">
                     <xsl:value-of select="xpdl:DataField/@Name"/>
                  </xsl:variable>
                  <xsl:variable name="isuff">
                     <xsl:value-of select="concat($i,'#',$suff)"/>
                  </xsl:variable>
                  <xforms:bind id="{$isuff}" nodeset="*/@Value[../@Id='{$i}']" type="long"/>
               </xsl:for-each>
               <xsl:for-each select="xpil:BooleanDataInstance">
                  <xsl:variable name="vext" select="prop:setProperty('variablesExist','true')"/>
                  <xsl:variable name="i">
                     <xsl:value-of select="@Id"/>
                  </xsl:variable>
                  <xsl:variable name="suff">
                     <xsl:value-of select="xpdl:DataField/@Name"/>
                  </xsl:variable>
                  <xsl:variable name="isuff">
                     <xsl:value-of select="concat($i,'#',$suff)"/>
                  </xsl:variable>
                  <xforms:bind id="{$isuff}" nodeset="*/@Value[../@Id='{$i}']" type="boolean"/>
               </xsl:for-each>
               <xsl:for-each select="xpil:DateDataInstance">
                  <xsl:variable name="vext" select="prop:setProperty('variablesExist','true')"/>
                  <xsl:variable name="i">
                     <xsl:value-of select="@Id"/>
                  </xsl:variable>
                  <xsl:variable name="suff">
                     <xsl:value-of select="xpdl:DataField/@Name"/>
                  </xsl:variable>
                  <xsl:variable name="isuff">
                     <xsl:value-of select="concat($i,'#',$suff)"/>
                  </xsl:variable>
                  <xforms:bind id="{$isuff}" nodeset="*/@Value[../@Id='{$i}']" type="date"/>
               </xsl:for-each>
            </xforms:model>
         </head>
<body>
<div id="w0">

<!-- page -->
<div id="pw0"><div id="pw">

<!-- header -->
<div id="ph"><div id="phw">
                    
<!-- toolbar -->
<div id="cnthdr">
	<div id="cnthdrw0">
		<div id="cnthdrw">
			<div class="h01">
				<h1>Variables</h1>
			</div>
		</div>
	</div>
</div>
<!-- toolbar end -->
</div></div>
<!-- header end-->

<!-- frame -->
<div id="cntframew" style="margin: 33px 0px 0px 0px; height:92%"><div id="cntframe"><div id="cnt01" style="width:100%; heigth:100%;">
<form action="javascript: void 0" id="mainForm" method="post" name="mainForm">
<input name="event" type="hidden"/>
<span style="color:red">
<table class="text" width="100%" border="0"
	align="center" cellpadding="0" cellspacing="0">

            
               <tr>
                  <td colspan="3">

            <xforms:group appearance="full">

               <xforms:label>GENERAL INFO</xforms:label>
               <xforms:output ref="/xpil:ExtendedWorkflowFacilityInstance/xpil:ManualActivityInstance/@Id">
                  <xforms:label>Id:</xforms:label>
               </xforms:output>
               <xforms:output ref="/xpil:ExtendedWorkflowFacilityInstance/xpil:ManualActivityInstance/@Name">
                  <xforms:label>Name:</xforms:label>
               </xforms:output>

               <xsl:variable name="temp1" select="prop:setProperty('viewProcDesc','false')"/>
               <xsl:variable name="temp2" select="prop:setProperty('updateProcDesc','false')"/>
               <xsl:variable name="temp3" select="prop:setProperty('viewProcPriority','false')"/>
               <xsl:variable name="temp4" select="prop:setProperty('updateProcPriority','false')"/>
               <xsl:variable name="temp5" select="prop:setProperty('viewActDesc','true')"/>
               <xsl:variable name="temp6" select="prop:setProperty('updateActDesc','false')"/>
               <xsl:variable name="temp7" select="prop:setProperty('viewActPriority','false')"/>
               <xsl:variable name="temp8" select="prop:setProperty('updateActPriority','false')"/>
               <xsl:for-each select="/xpil:ExtendedWorkflowFacilityInstance/xpil:MainWorkflowProcessInstance/xpil:InstanceExtendedAttributes">
                  <xsl:if test="xpil:InstanceExtendedAttribute/@Name='PROCESS_DESCRIPTION_VIEW'">
                     <xsl:variable name="temp1" select="prop:setProperty('viewProcDesc','true')"/>
                  </xsl:if>
                  <xsl:if test="xpil:InstanceExtendedAttribute/@Name='PROCESS_PRIORITY_VIEW'">
                     <xsl:variable name="temp1" select="prop:setProperty('viewProcPriority','true')"/>
                  </xsl:if>
               </xsl:for-each>
               <xsl:for-each select="/xpil:ExtendedWorkflowFacilityInstance/xpil:SubWorkflowProcessInstance/xpil:InstanceExtendedAttributes">
                  <xsl:if test="xpil:InstanceExtendedAttribute/@Name='PROCESS_DESCRIPTION_VIEW'">
                     <xsl:variable name="temp1" select="prop:setProperty('viewProcDesc','true')"/>
                  </xsl:if>
                  <xsl:if test="xpil:InstanceExtendedAttribute/@Name='PROCESS_PRIORITY_VIEW'">
                     <xsl:variable name="temp1" select="prop:setProperty('viewProcPriority','true')"/>
                  </xsl:if>
               </xsl:for-each>
               <xsl:for-each select="/xpil:ExtendedWorkflowFacilityInstance/xpil:MainWorkflowProcessInstance/xpil:InstanceExtendedAttributes">
                  <xsl:if test="xpil:InstanceExtendedAttribute/@Name='PROCESS_DESCRIPTION_UPDATE'">
                     <xsl:variable name="temp1" select="prop:setProperty('viewProcDesc','false')"/>
                     <xsl:variable name="temp2" select="prop:setProperty('updateProcDesc','true')"/>
                  </xsl:if>
                  <xsl:if test="xpil:InstanceExtendedAttribute/@Name='PROCESS_PRIORITY_UPDATE'">
                     <xsl:variable name="temp1" select="prop:setProperty('viewProcPriority','false')"/>
                     <xsl:variable name="temp2" select="prop:setProperty('updateProcPriority','true')"/>
                  </xsl:if>
               </xsl:for-each>
               <xsl:for-each select="/xpil:ExtendedWorkflowFacilityInstance/xpil:SubWorkflowProcessInstance/xpil:InstanceExtendedAttributes">
                  <xsl:if test="xpil:InstanceExtendedAttribute/@Name='PROCESS_DESCRIPTION_UPDATE'">
                     <xsl:variable name="temp1" select="prop:setProperty('viewProcDesc','false')"/>
                     <xsl:variable name="temp2" select="prop:setProperty('updateProcDesc','true')"/>
                  </xsl:if>
                  <xsl:if test="xpil:InstanceExtendedAttribute/@Name='PROCESS_PRIORITY_UPDATE'">
                     <xsl:variable name="temp1" select="prop:setProperty('viewProcPriority','false')"/>
                     <xsl:variable name="temp2" select="prop:setProperty('updateProcPriority','true')"/>
                  </xsl:if>
               </xsl:for-each>
               <xsl:for-each select="/xpil:ExtendedWorkflowFacilityInstance/xpil:ManualActivityInstance/xpil:InstanceExtendedAttributes">
                  <xsl:if test="xpil:InstanceExtendedAttribute/@Name='ACTIVITY_DESCRIPTION_VIEW'">
                     <xsl:variable name="temp1" select="prop:setProperty('viewActDesc','true')"/>
                  </xsl:if>
                  <xsl:if test="xpil:InstanceExtendedAttribute/@Name='ACTIVITY_PRIORITY_VIEW'">
                     <xsl:variable name="temp1" select="prop:setProperty('viewActPriority','true')"/>
                  </xsl:if>
               </xsl:for-each>
               <xsl:for-each select="/xpil:ExtendedWorkflowFacilityInstance/xpil:ManualActivityInstance/xpil:InstanceExtendedAttributes">
                  <xsl:if test="xpil:InstanceExtendedAttribute/@Name='ACTIVITY_DESCRIPTION_UPDATE'">
                     <xsl:variable name="temp1" select="prop:setProperty('viewActDesc','false')"/>
                     <xsl:variable name="temp2" select="prop:setProperty('updateActDesc','true')"/>
                  </xsl:if>
                  <xsl:if test="xpil:InstanceExtendedAttribute/@Name='ACTIVITY_PRIORITY_UPDATE'">
                     <xsl:variable name="temp1" select="prop:setProperty('viewActPriority','false')"/>
                     <xsl:variable name="temp2" select="prop:setProperty('updateActPriority','true')"/>
                  </xsl:if>
               </xsl:for-each>

               <xsl:variable name="t1" select="prop:getProperty('viewProcDesc')"/>
               <xsl:variable name="t2" select="prop:getProperty('updateProcDesc')"/>
               <xsl:variable name="t3" select="prop:getProperty('viewProcPriority')"/>
               <xsl:variable name="t4" select="prop:getProperty('updateProcPriority')"/>
               <xsl:variable name="t5" select="prop:getProperty('viewActDesc')"/>
               <xsl:variable name="t6" select="prop:getProperty('updateActDesc')"/>
               <xsl:variable name="t7" select="prop:getProperty('viewActPriority')"/>
               <xsl:variable name="t8" select="prop:getProperty('updateActPriority')"/>
               <xsl:choose>
                  <xsl:when test="$t1='true'">
                     <xsl:if test="/xpil:ExtendedWorkflowFacilityInstance/xpil:MainWorkflowProcessInstance">
                        <xforms:output ref="/xpil:ExtendedWorkflowFacilityInstance/xpil:MainWorkflowProcessInstance/xpil:InstanceDescription">
                           <xforms:label>Process Description:</xforms:label>
                        </xforms:output>
                     </xsl:if>
                     <xsl:if test="/xpil:ExtendedWorkflowFacilityInstance/xpil:SubWorkflowProcessInstance">
                        <xforms:output ref="/xpil:ExtendedWorkflowFacilityInstance/xpil:SubWorkflowProcessInstance/xpil:InstanceDescription">
                           <xforms:label>Process Description:</xforms:label>
                        </xforms:output>
                     </xsl:if>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:choose>
                        <xsl:when test="$t2='true'">
                           <xsl:if test="/xpil:ExtendedWorkflowFacilityInstance/xpil:MainWorkflowProcessInstance">
                              <xforms:input ref="/xpil:ExtendedWorkflowFacilityInstance/xpil:MainWorkflowProcessInstance/xpil:InstanceDescription">
                                 <xforms:label>Process Description:</xforms:label>
                              </xforms:input>
                           </xsl:if>
                           <xsl:if test="/xpil:ExtendedWorkflowFacilityInstance/xpil:SubWorkflowProcessInstance">
                              <xforms:input ref="/xpil:ExtendedWorkflowFacilityInstance/xpil:SubWorkflowProcessInstance/xpil:InstanceDescription">
                                 <xforms:label>Process Description:</xforms:label>
                              </xforms:input>
                           </xsl:if>
                        </xsl:when>
                     </xsl:choose>
                  </xsl:otherwise>
               </xsl:choose>
               <xsl:choose>
                  <xsl:when test="$t3='true'">
                     <xsl:if test="/xpil:ExtendedWorkflowFacilityInstance/xpil:MainWorkflowProcessInstance">
                        <xforms:output ref="/xpil:ExtendedWorkflowFacilityInstance/xpil:MainWorkflowProcessInstance/xpil:InstancePriority">
                           <xforms:label>Process Priority:</xforms:label>
                        </xforms:output>
                     </xsl:if>
                     <xsl:if test="/xpil:ExtendedWorkflowFacilityInstance/xpil:SubWorkflowProcessInstance">
                        <xforms:output ref="/xpil:ExtendedWorkflowFacilityInstance/xpil:SubWorkflowProcessInstance/xpil:InstancePriority">
                           <xforms:label>Process Priority:</xforms:label>
                        </xforms:output>
                     </xsl:if>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:choose>
                        <xsl:when test="$t4='true'">
                           <xsl:if test="/xpil:ExtendedWorkflowFacilityInstance/xpil:MainWorkflowProcessInstance">
                              <xforms:input ref="/xpil:ExtendedWorkflowFacilityInstance/xpil:MainWorkflowProcessInstance/xpil:InstancePriority">
                                 <xforms:label>Process Priority:</xforms:label>
                              </xforms:input>
                           </xsl:if>
                           <xsl:if test="/xpil:ExtendedWorkflowFacilityInstance/xpil:SubWorkflowProcessInstance">
                              <xforms:input ref="/xpil:ExtendedWorkflowFacilityInstance/xpil:SubWorkflowProcessInstance/xpil:InstancePriority">
                                 <xforms:label>Process Priority:</xforms:label>
                              </xforms:input>
                           </xsl:if>
                        </xsl:when>
                     </xsl:choose>
                  </xsl:otherwise>
               </xsl:choose>
               <xsl:choose>
                  <xsl:when test="$t5='true'">
                     <xforms:output ref="/xpil:ExtendedWorkflowFacilityInstance/xpil:ManualActivityInstance/xpil:InstanceDescription">
                        <xforms:label>Description:</xforms:label>
                     </xforms:output>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:choose>
                        <xsl:when test="$t6='true'">
                           <xforms:input ref="/xpil:ExtendedWorkflowFacilityInstance/xpil:ManualActivityInstance/xpil:InstanceDescription">
                              <xforms:label>Description:</xforms:label>
                           </xforms:input>
                        </xsl:when>
                     </xsl:choose>
                  </xsl:otherwise>
               </xsl:choose>
               <xsl:choose>
                  <xsl:when test="$t7='true'">
                     <xforms:output ref="/xpil:ExtendedWorkflowFacilityInstance/xpil:ManualActivityInstance/xpil:InstancePriority">
                        <xforms:label>Priority:</xforms:label>
                     </xforms:output>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:choose>
                        <xsl:when test="$t8='true'">
                           <xforms:input ref="/xpil:ExtendedWorkflowFacilityInstance/xpil:ManualActivityInstance/xpil:InstancePriority">
                              <xforms:label>Priority:</xforms:label>
                           </xforms:input>
                        </xsl:when>
                     </xsl:choose>
                  </xsl:otherwise>
               </xsl:choose>
            </xforms:group>

            <xforms:group appearance="full">

            <xsl:variable name="vext" select="prop:getProperty('variablesExist')"/>

            <xsl:if test="$vext='true'">
               <xforms:label>PROPERTIES</xforms:label>
               <xsl:for-each select="//.">

                  <xsl:if test="name()='xpil:StringDataInstance'">
                     <xsl:variable name="i">
                        <xsl:value-of select="@Id"/>
                     </xsl:variable>
                     <xsl:variable name="suff">
                        <xsl:value-of select="xpdl:DataField/@Name"/>
                     </xsl:variable>
                     <xsl:variable name="isuff">
                        <xsl:value-of select="concat($i,'#',$suff)"/>
                     </xsl:variable>
                     <xsl:choose>
                        <!-- VariableToProcess_UPDATE -->
                        <xsl:when test="xpil:InstanceExtendedAttributes/xpil:InstanceExtendedAttribute/@Value=1">
                           <xsl:choose>
                              <!-- LARGE SIZE -->
                              <xsl:when test="xpdl:DataField/xpdl:ExtendedAttributes/xpdl:ExtendedAttribute/@Name='RENDERING_HINT' and xpdl:DataField/xpdl:ExtendedAttributes/xpdl:ExtendedAttribute/@Value='Size=L'">
                                 <xforms:textarea bind="{$isuff}">
                                    <xforms:label>
                                       <xsl:choose>
                                          <xsl:when test="$suff!=''">
                                             <xsl:value-of select="$suff"/>
                                          </xsl:when>
                                          <xsl:otherwise>
                                             <xsl:value-of select="$i"/>
                                          </xsl:otherwise>
                                       </xsl:choose>
                                    </xforms:label>
                                    <xforms:alert>Please enter valid value!</xforms:alert>
                                 </xforms:textarea>
                              </xsl:when>
                              <xsl:otherwise>
                                 <xforms:input bind="{$isuff}">
                                    <xforms:label>
                                       <xsl:choose>
                                          <xsl:when test="$suff!=''">
                                             <xsl:value-of select="$suff"/>
                                          </xsl:when>
                                          <xsl:otherwise>
                                             <xsl:value-of select="$i"/>
                                          </xsl:otherwise>
                                       </xsl:choose>
                                    </xforms:label>
                                    <xforms:alert>Please enter valid value!</xforms:alert>
                                 </xforms:input>
                              </xsl:otherwise>
                           </xsl:choose>
                        </xsl:when>
                        <!-- VariableToProcess_VIEW -->
                        <xsl:when test="xpil:InstanceExtendedAttributes/xpil:InstanceExtendedAttribute/@Value=0">
                           <xforms:output bind="{$isuff}">
                              <xforms:label>
                                 <xsl:choose>
                                    <xsl:when test="$suff!=''">
                                       <xsl:value-of select="$suff"/>
                                    </xsl:when>
                                    <xsl:otherwise>
                                       <xsl:value-of select="$i"/>
                                    </xsl:otherwise>
                                 </xsl:choose>
                              </xforms:label>
                           </xforms:output>
                        </xsl:when>
                        <!-- VariableToProcess_FETCH -->
                        <xsl:when test="xpil:InstanceExtendedAttributes/xpil:InstanceExtendedAttribute/@Value=2">
                           <xsl:variable name="variableId" select="xpil:InstanceExtendedAttributes/xpil:InstanceExtendedAttribute[2]/@Value" /> <!-- determine source variable Id -->
                           <xsl:variable name="variableElement" select="../xpil:StringDataInstance[@Id=$variableId]" /><!-- fetch element with id -->
                           <xsl:variable name="variableValue" select="$variableElement/@Value" /><!-- fetch value for specified id -->
                           <xforms:select1 appearance="minimal" bind="{$isuff}">
                              <xforms:label>
                                 <xsl:choose>
                                    <xsl:when test="$suff!=''">
                                       <xsl:value-of select="$suff"/>
                                    </xsl:when>
                                    <xsl:otherwise>
                                       <xsl:value-of select="$i"/>
                                    </xsl:otherwise>
                                 </xsl:choose>
                              </xforms:label>
                              <xsl:for-each select="str:tokenize($variableValue, ';')">
                                 <xforms:item>
                                  <xforms:label><xsl:value-of select="."/></xforms:label>
                                  <xforms:value><xsl:value-of select="."/></xforms:value>
                               </xforms:item>
                              </xsl:for-each>
                           </xforms:select1>
                        </xsl:when>
                     </xsl:choose>
                  </xsl:if>
                  <xsl:if test="name()='xpil:DoubleDataInstance'">
                     <xsl:variable name="i">
                        <xsl:value-of select="@Id"/>
                     </xsl:variable>
                     <xsl:variable name="suff">
                        <xsl:value-of select="xpdl:DataField/@Name"/>
                     </xsl:variable>
                     <xsl:variable name="isuff">
                        <xsl:value-of select="concat($i,'#',$suff)"/>
                     </xsl:variable>
                     <xsl:choose>
                        <xsl:when test="xpil:InstanceExtendedAttributes/xpil:InstanceExtendedAttribute/@Value=1">
                           <xforms:input bind="{$isuff}">
                              <xforms:label>
                                 <xsl:choose>
                                    <xsl:when test="$suff!=''">
                                       <xsl:value-of select="$suff"/>
                                    </xsl:when>
                                    <xsl:otherwise>
                                       <xsl:value-of select="$i"/>
                                    </xsl:otherwise>
                                 </xsl:choose>
                              </xforms:label>
                              <xforms:alert>Please enter valid value!</xforms:alert>
                           </xforms:input>
                        </xsl:when>
                        <xsl:when test="xpil:InstanceExtendedAttributes/xpil:InstanceExtendedAttribute/@Value=0">
                           <xforms:output bind="{$isuff}">
                              <xforms:label>
                                 <xsl:choose>
                                    <xsl:when test="$suff!=''">
                                       <xsl:value-of select="$suff"/>
                                    </xsl:when>
                                    <xsl:otherwise>
                                       <xsl:value-of select="$i"/>
                                    </xsl:otherwise>
                                 </xsl:choose>
                              </xforms:label>
                           </xforms:output>
                        </xsl:when>
                        <xsl:when test="xpil:InstanceExtendedAttributes/xpil:InstanceExtendedAttribute/@Value=2">
                           <xsl:variable name="variableId" select="xpil:InstanceExtendedAttributes/xpil:InstanceExtendedAttribute[2]/@Value" /> <!-- determine source variable Id -->
                           <xsl:variable name="variableElement" select="../xpil:StringDataInstance[@Id=$variableId]" /><!-- fetch element with id -->
                           <xsl:variable name="variableValue" select="$variableElement/@Value" /><!-- fetch value for specified id -->
                           <xforms:select1 appearance="minimal" bind="{$isuff}">
                              <xforms:label>
                                 <xsl:choose>
                                    <xsl:when test="$suff!=''">
                                       <xsl:value-of select="$suff"/>
                                    </xsl:when>
                                    <xsl:otherwise>
                                       <xsl:value-of select="$i"/>
                                    </xsl:otherwise>
                                 </xsl:choose>
                              </xforms:label>
                              <xsl:for-each select="str:tokenize($variableValue, ';')">
                                 <xforms:item>
                                  <xforms:label><xsl:value-of select="."/></xforms:label>
                                  <xforms:value><xsl:value-of select="."/></xforms:value>
                               </xforms:item>
                              </xsl:for-each>
                           </xforms:select1>
                        </xsl:when>
                     </xsl:choose>
                  </xsl:if>
                  <xsl:if test="name()='xpil:LongDataInstance'">
                     <xsl:variable name="i">
                        <xsl:value-of select="@Id"/>
                     </xsl:variable>
                     <xsl:variable name="suff">
                        <xsl:value-of select="xpdl:DataField/@Name"/>
                     </xsl:variable>
                     <xsl:variable name="isuff">
                        <xsl:value-of select="concat($i,'#',$suff)"/>
                     </xsl:variable>
                     <xsl:choose>
                        <xsl:when test="xpil:InstanceExtendedAttributes/xpil:InstanceExtendedAttribute/@Value=1">
                           <xforms:input bind="{$isuff}">
                              <xforms:label>
                                 <xsl:choose>
                                    <xsl:when test="$suff!=''">
                                       <xsl:value-of select="$suff"/>
                                    </xsl:when>
                                    <xsl:otherwise>
                                       <xsl:value-of select="$i"/>
                                    </xsl:otherwise>
                                 </xsl:choose>
                              </xforms:label>
                              <xforms:alert>Please enter valid value!</xforms:alert>
                           </xforms:input>
                        </xsl:when>
                        <xsl:when test="xpil:InstanceExtendedAttributes/xpil:InstanceExtendedAttribute/@Value=0">
                           <xforms:output bind="{$isuff}">
                              <xforms:label>
                                 <xsl:choose>
                                    <xsl:when test="$suff!=''">
                                       <xsl:value-of select="$suff"/>
                                    </xsl:when>
                                    <xsl:otherwise>
                                       <xsl:value-of select="$i"/>
                                    </xsl:otherwise>
                                 </xsl:choose>
                              </xforms:label>
                           </xforms:output>
                        </xsl:when>
                        <xsl:when test="xpil:InstanceExtendedAttributes/xpil:InstanceExtendedAttribute/@Value=2">
                           <xsl:variable name="variableId" select="xpil:InstanceExtendedAttributes/xpil:InstanceExtendedAttribute[2]/@Value" /> <!-- determine source variable Id -->
                           <xsl:variable name="variableElement" select="../xpil:StringDataInstance[@Id=$variableId]" /><!-- fetch element with id -->
                           <xsl:variable name="variableValue" select="$variableElement/@Value" /><!-- fetch value for specified id -->
                           <xforms:select1 appearance="minimal" bind="{$isuff}">
                              <xforms:label>
                                 <xsl:choose>
                                    <xsl:when test="$suff!=''">
                                       <xsl:value-of select="$suff"/>
                                    </xsl:when>
                                    <xsl:otherwise>
                                       <xsl:value-of select="$i"/>
                                    </xsl:otherwise>
                                 </xsl:choose>
                              </xforms:label>
                              <xsl:for-each select="str:tokenize($variableValue, ';')">
                                 <xforms:item>
                                  <xforms:label><xsl:value-of select="."/></xforms:label>
                                  <xforms:value><xsl:value-of select="."/></xforms:value>
                               </xforms:item>
                              </xsl:for-each>
                           </xforms:select1>
                        </xsl:when>
                     </xsl:choose>
                  </xsl:if>
                  <xsl:if test="name()='xpil:BooleanDataInstance'">
                     <xsl:variable name="i">
                        <xsl:value-of select="@Id"/>
                     </xsl:variable>
                     <xsl:variable name="suff">
                        <xsl:value-of select="xpdl:DataField/@Name"/>
                     </xsl:variable>
                     <xsl:variable name="isuff">
                        <xsl:value-of select="concat($i,'#',$suff)"/>
                     </xsl:variable>
                     <xsl:choose>
                        <xsl:when test="xpil:InstanceExtendedAttributes/xpil:InstanceExtendedAttribute/@Value=1">
                           <xforms:select1 bind="{$isuff}" appearance="full" selection="open">
                              <xforms:label>
                                 <xsl:choose>
                                    <xsl:when test="$suff!=''">
                                       <xsl:value-of select="$suff"/>
                                    </xsl:when>
                                    <xsl:otherwise>
                                       <xsl:value-of select="$i"/>
                                    </xsl:otherwise>
                                 </xsl:choose>
                              </xforms:label>
                              <xforms:item>
                                 <xforms:label>true</xforms:label>
                                 <xforms:value>true</xforms:value>
                              </xforms:item>
                              <xforms:item>
                                 <xforms:label>false</xforms:label>
                                 <xforms:value>false</xforms:value>
                              </xforms:item>
                           </xforms:select1>
                        </xsl:when>
                        <xsl:when test="xpil:InstanceExtendedAttributes/xpil:InstanceExtendedAttribute/@Value=0">
                           <xforms:output bind="{$isuff}">
                              <xforms:label>
                                 <xsl:choose>
                                    <xsl:when test="$suff!=''">
                                       <xsl:value-of select="$suff"/>
                                    </xsl:when>
                                    <xsl:otherwise>
                                       <xsl:value-of select="$i"/>
                                    </xsl:otherwise>
                                 </xsl:choose>
                              </xforms:label>
                           </xforms:output>
                        </xsl:when>
                     </xsl:choose>
                  </xsl:if>
                  <xsl:if test="name()='xpil:DateDataInstance'">
                     <xsl:variable name="i">
                        <xsl:value-of select="@Id"/>
                     </xsl:variable>
                     <xsl:variable name="suff">
                        <xsl:value-of select="xpdl:DataField/@Name"/>
                     </xsl:variable>
                     <xsl:variable name="isuff">
                        <xsl:value-of select="concat($i,'#',$suff)"/>
                     </xsl:variable>
                     <xsl:choose>
                        <xsl:when test="xpil:InstanceExtendedAttributes/xpil:InstanceExtendedAttribute/@Value=1">
                           <xforms:input appearance="full" bind="{$isuff}">
                              <xforms:label>
                                 <xsl:choose>
                                    <xsl:when test="$suff!=''">
                                       <xsl:value-of select="$suff"/>
                                    </xsl:when>
                                    <xsl:otherwise>
                                       <xsl:value-of select="$i"/>
                                    </xsl:otherwise>
                                 </xsl:choose>
                              </xforms:label>
                              <xforms:alert>Please enter valid value!</xforms:alert>
                           </xforms:input>
                        </xsl:when>
                        <xsl:when test="xpil:InstanceExtendedAttributes/xpil:InstanceExtendedAttribute/@Value=0">
                           <xforms:output bind="{$isuff}">
                              <xforms:label>
                                 <xsl:choose>
                                    <xsl:when test="$suff!=''">
                                       <xsl:value-of select="$suff"/>
                                    </xsl:when>
                                    <xsl:otherwise>
                                       <xsl:value-of select="$i"/>
                                    </xsl:otherwise>
                                 </xsl:choose>
                              </xforms:label>
                           </xforms:output>
                        </xsl:when>
                     </xsl:choose>
                  </xsl:if>
               </xsl:for-each>
            </xsl:if>
            </xforms:group>
            <xforms:group>
              <xforms:submit submission="complete">
                  <xforms:label> Complete </xforms:label>
               </xforms:submit>
               <xsl:variable name="vext" select="prop:getProperty('variablesExist')"/>
               <xsl:if test="$vext='true'">
                  <xforms:submit submission="update">
                     <xforms:label> Update </xforms:label>
                  </xforms:submit>
               </xsl:if>
               <xforms:submit submission="close">
                  <xforms:label> Cancel </xforms:label>
               </xforms:submit>


            </xforms:group>
                  </td>
							<td width="2%" />
               </tr>
               <xsl:if test="$sharkEdition!='community' and $edmWebDAVAllowed='true' and $isWebDAVVisible='true'">
                        <tr height="600px" >
						<xsl:variable name="webDAVurl">/sharkWebClient/webdav/<xsl:value-of select="/xpil:ExtendedWorkflowFacilityInstance/xpil:MainWorkflowProcessInstance/@Id" />/<xsl:value-of select="/xpil:ExtendedWorkflowFacilityInstance/xpil:ManualActivityInstance/@Id" />?session_xsl=documents.xsl&#38;sessionKey=<xsl:value-of select="$sessionKey"/>&#38;resourcePath=/sharkWebClient/prof/edm&#38;itemsPerPage=25&#38;previewerURL=<xsl:value-of select='$protocol'/>://<xsl:value-of select='$host'/>:<xsl:value-of select='$port'/>/tdv/Preview.po
						</xsl:variable>	
						 <td colspan="4">
						  
			              <frameset>
				           <iframe name="tablefrm" id="tablefrm" width="98%" height="100%" frameborder="no" src="{$webDAVurl}" ></iframe>
			              </frameset>
	                    
						 </td>
						
						 </tr>
						 </xsl:if>
</table>
</span>					 
</form>
</div>
</div></div>
<!-- frame end -->    

<!-- footer -->
	<xsl:call-template name="Footer"></xsl:call-template>
<!-- footer end -->

</div></div>
<!-- page end -->

</div>

<script type="text/javascript">
//<![CDATA[

dynStyleSet(['tbodyFrame']);

//]]>
</script>

</body>
</html>
</xsl:template>
</xsl:stylesheet>