<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" exclude-result-prefixes="xpil" xmlns:xpil="http://www.together.at/2006/XPIL1.0" xmlns:xpd="http://www.wfmc.org/2002/XPDL1.0" version="1.0">
   <xsl:template name="Navigation">
		<div style="width:30%; padding-top:7px;">
			<xsl:if test="number($from_element) &lt; number($to_element)">
				<xsl:variable name="resultPerPage" select="number(number($to_element)-number($from_element)+1)"/>
				<xsl:variable name="temp" select="number($from_element)+number($resultPerPage)"/>
				<xsl:variable name="thisPage" select="round(number($temp) div number($resultPerPage))"/>
				<xsl:variable name="posibleNumberPages" select="round(number($total_number) div $resultPerPage+0.4)"/>
				<xsl:if test="$posibleNumberPages > 1">
					
						<xsl:variable name="urlP"><xsl:value-of select="$navig_url"/>?&#38;from=<xsl:value-of select="number((number($thisPage)-2)*$resultPerPage)"/>&#38;sortCriterion=<xsl:value-of select="$sortCriterion"/>&#38;sortAsc=<xsl:value-of select="$sortAsc"/>&#38;selected_user=<xsl:value-of select="$selected_user"/></xsl:variable>
						<xsl:variable name="urlFirst"><xsl:value-of select="$navig_url"/>?&#38;from=0&#38;sortCriterion=<xsl:value-of select="$sortCriterion"/>&#38;sortAsc=<xsl:value-of select="$sortAsc"/>&#38;selected_user=<xsl:value-of select="$selected_user"/></xsl:variable>						
						
						<span style="float:left; padding-right: 7px;">
							<xsl:element name="a">
								<xsl:attribute name="href">
									<xsl:value-of select="$urlFirst"/>
								</xsl:attribute>
								<xsl:if test="$thisPage!='1'">
									<xsl:attribute name="style">
										<xsl:value-of select="'visibility:visible'"/>
									</xsl:attribute>	
								</xsl:if>
								<xsl:if test="$thisPage='1'">
									<xsl:attribute name="style">
										<xsl:value-of select="'visibility:hidden'"/>
									</xsl:attribute>	
								</xsl:if>
								<img src="images/leftF.gif" border="0" alt="First Page"/>
							</xsl:element>
							<xsl:element name="a">
								<xsl:attribute name="href">
									<xsl:value-of select="$urlP"/>
								</xsl:attribute>
								<xsl:if test="$thisPage!='1'">
									<xsl:attribute name="style">
										<xsl:value-of select="'visibility:visible'"/>
									</xsl:attribute>	
								</xsl:if>
								<xsl:if test="$thisPage='1'">
									<xsl:attribute name="style">
										<xsl:value-of select="'visibility:hidden'"/>
									</xsl:attribute>	
								</xsl:if>
								<img src="images/left.gif" border="0" alt="Previous Page"/>
							</xsl:element>
						</span>

					
					<xsl:variable name="end" select="number($thisPage+5)"/>
					
					<xsl:choose>
						<xsl:when test="$end > $posibleNumberPages">
							<xsl:call-template name="add">
								<xsl:with-param name="n">
									<xsl:value-of select="$posibleNumberPages"/>
								</xsl:with-param>
								<xsl:with-param name="thisPage">
									<xsl:value-of select="$thisPage"/>
								</xsl:with-param>
								<xsl:with-param name="resultPerPage">
									<xsl:value-of select="$resultPerPage"/>
								</xsl:with-param>
							</xsl:call-template>
						</xsl:when>
						<xsl:otherwise>
							<xsl:call-template name="add">
								<xsl:with-param name="n">
									<xsl:value-of select="$end"/>
								</xsl:with-param>
								<xsl:with-param name="thisPage">
									<xsl:value-of select="$thisPage"/>
								</xsl:with-param>
								<xsl:with-param name="resultPerPage">
									<xsl:value-of select="$resultPerPage"/>
								</xsl:with-param>
							</xsl:call-template>
						</xsl:otherwise>
					</xsl:choose>
					<xsl:if test="$posibleNumberPages >  $thisPage">
						<xsl:variable name="urlN"><xsl:value-of select="$navig_url"/>?&#38;from=<xsl:value-of select="number(($thisPage*$resultPerPage))"/>&#38;sortCriterion=<xsl:value-of select="$sortCriterion"/>&#38;sortAsc=<xsl:value-of select="$sortAsc"/>&#38;selected_user=<xsl:value-of select="$selected_user"/></xsl:variable>
						<xsl:variable name="urlLast"><xsl:value-of select="$navig_url"/>?&#38;from=<xsl:value-of select="number($posibleNumberPages*$resultPerPage)"/>&#38;sortCriterion=<xsl:value-of select="$sortCriterion"/>&#38;sortAsc=<xsl:value-of select="$sortAsc"/>&#38;selected_user=<xsl:value-of select="$selected_user"/></xsl:variable>
						
						<span style="float:left; padding-left: 4px;">
						<a HREF="{$urlN}">
							 <img src="images/right.gif" border="0" alt="Next Page"/>
						</a>
						<a HREF="{$urlLast}">
							 <img src="images/rightL.gif" border="0" alt="Last Page"/>
						</a>
						</span>
					</xsl:if>
				</xsl:if>
			</xsl:if>
		</div>
	</xsl:template>
	<xsl:template name="add">
		<xsl:param name="n"/>
		<xsl:param name="thisPage"/>
		<xsl:param name="resultPerPage"/>		
		<xsl:if test="number($n) &gt; $thisPage - 5 and number($n) &gt; 1">
			<xsl:call-template name="add">
				<xsl:with-param name="n" select="number($n) - 1"/>
				<xsl:with-param name="thisPage" select="$thisPage"/>
				<xsl:with-param name="resultPerPage" select="$resultPerPage"/>
			</xsl:call-template>
		</xsl:if>
		<xsl:choose>
			<xsl:when test="$n != $thisPage">
				<xsl:variable name="urlN"><xsl:value-of select="$navig_url"/>?&#38;from=<xsl:value-of select="number(($n*$resultPerPage) - $resultPerPage)"/>&#38;sortCriterion=<xsl:value-of select="$sortCriterion"/>&#38;sortAsc=<xsl:value-of select="$sortAsc"/>&#38;selected_user=<xsl:value-of select="$selected_user"/>
				</xsl:variable>

				<a style="float:left; padding-right:3px;" href="{$urlN}">
					<font size="2" face="Arial" color="#20427f">
						<xsl:value-of select="$n"/>
					</font>
				</a>
			</xsl:when>
			<xsl:otherwise>
				<font style="float:left; padding-right:3px;" size="2" face="Arial" color="#96171A" >
					<xsl:value-of select="$n"/>
				</font>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
</xsl:stylesheet>
