<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
exclude-result-prefixes="xpil"
xmlns:xpil="http://www.together.at/2006/XPIL1.0"
xmlns:prop="java.util.Properties"
xmlns:xpdl="http://www.wfmc.org/2002/XPDL1.0" version="1.0">
	<xsl:output method="html" />
	<xsl:param name="auth_type" select="FORM" />
	<xsl:param name="username" select="u" />
	<xsl:param name="from_element" select="11" />
	<xsl:param name="to_element" select="20" />
	<xsl:param name="sortCriterion" select="20" />
	<xsl:param name="sortAsc" select="true" />
	<xsl:param name="total_number" select="200" />
	<xsl:param name="fromPage" select="p" />
	<xsl:param name="sharkEdition" select="e" />
	<xsl:param name="navig_url" select="ProcessActivitiesHandlerPO.po" />

<xsl:include xmlns:xsl="http://www.w3.org/1999/XSL/Transform" href="properties.xsl" />
<xsl:include xmlns:xsl="http://www.w3.org/1999/XSL/Transform" href="menu.xsl" />
<xsl:include xmlns:xsl="http://www.w3.org/1999/XSL/Transform" href="footer.xsl" />
<xsl:template match="xpil:ExtendedWorkflowFacilityInstance">

<html xmlns="http://www.w3.org/1999/xhtml">

<head>
<meta http-equiv="content-type" content="text/html; charset='UTF-8'"/>
<title>History</title>
<link href="styles/style.css" rel="stylesheet" type="text/css" media="screen,projection,tv"/>
<link href="styles/style_ie.css" rel="stylesheet" type="text/css" media="screen,projection,tv"/>

<!--[if lte IE 6]>
<link href="styles/style_iel.css" rel="stylesheet" type="text/css" media="screen,projection,tv">
<![endif]-->
<!--[if gte IE 7]>
<link href="styles/style_ie.css" rel="stylesheet" type="text/css" media="screen,projection,tv">
<![endif]-->
<!--[if gte IE 8]>
<link href="styles/style_ien.css" rel="stylesheet" type="text/css" media="screen,projection,tv">
<![endif]-->
<script type="text/javascript" src="js/jslib.js"></script>
<script type="text/javascript" src="js/dynstyles.js"></script>

<script type="text/javascript" xmlns:prop="java.util.Properties" xmlns:xml="http://www.w3.org/XML/1998/namespace" xmlns:xpdl="http://www.wfmc.org/2002/XPDL1.0">

function submitForm(formId, actionAttr) {
  var formTag = document.getElementById(formId);
  formTag.action=actionAttr;
  formTag.submit();
}

function submitFormEvent(formId, actionAttr,event) {
  var formTag = document.getElementById(formId);
  formTag.action=actionAttr;
  formTag.event.value=event;
  formTag.submit();
}

function openNewDialogWindow(pageName,windowName,parameters) {
  window.open(pageName,windowName,parameters); 
}

function submitContentFormWithAction(formId,actionAttr,event, txt) {
  if(confirm(txt)) {
    alreadySubmited = true;
    if(window.event != null)
    window.event.returnValue = false;
    var formTag = document.getElementById(formId);
    formTag.action=actionAttr;
    formTag.event.value=event;
    formTag.submit();
  }
}
	
</script>
</head>
<body>
<form action="javascript: void 0" id="mainForm" method="post" name="mainForm">
<input name="event" type="hidden"/>
<input id="rememberArrowId" type="hidden"/>
<input id="rememberArrowStyle" type="hidden"/>
<div id="w0">

<!-- page -->
<div id="pw0"><div id="pw">

<!-- header -->
<div id="ph"><div id="phw">

<!-- header menu -->
	<xsl:call-template name="Menu">
		<xsl:with-param name="prop_repository" select="prop:getProperty('repository','true')" />
		<xsl:with-param name="prop_packagelist" select="prop:getProperty('packagelist','true')" />
		<xsl:with-param name="prop_processinst" select="prop:getProperty('processinst','true')" />
		<xsl:with-param name="prop_processmonitor" select="prop:getProperty('processmonitor','true')" />
		<xsl:with-param name="prop_usermanag" select="prop:getProperty('usermanag','true')" />
		<xsl:with-param name="prop_worklist" select="prop:getProperty('worklist','true')" />
		<xsl:with-param name="prop_processlist" select="prop:getProperty('processlist','true')" />
		<xsl:with-param name="prop_cache" select="prop:getProperty('cache','true')" />
		<xsl:with-param name="prop_application" select="prop:getProperty('application','true')" />
		<xsl:with-param name="prop_participant" select="prop:getProperty('participant','true')" />
		<xsl:with-param name="prop_groupmanag" select="prop:getProperty('groupmanag','true')" />
		<xsl:with-param name="sharkEdition" select="$sharkEdition"/>
	</xsl:call-template>
<!-- header menu end -->	
                    
<!-- toolbar -->
<div id="cnthdr">
	<div id="cnthdrw0">
		<div id="cnthdrw">
			<div class="h01">
				<xsl:variable name="process_id">
					<xsl:value-of select="xpil:InstanceExtendedAttributes/xpil:InstanceExtendedAttribute[1]/@Value"/>
					</xsl:variable>
					<xsl:variable name="act_id">
					<xsl:value-of select="xpil:InstanceExtendedAttributes/xpil:InstanceExtendedAttribute[2]/@Value"/>
					</xsl:variable>
					<xsl:if test="$act_id!='NaN'">
						  <h1>Activity History</h1>
						  <span class="tmdata"><b>Process Id : </b> <xsl:value-of select="xpil:InstanceExtendedAttributes/xpil:InstanceExtendedAttribute[1]/@Value"/></span>
						  <span class="tmdata"><b>Activity Id : </b> <xsl:value-of select="xpil:InstanceExtendedAttributes/xpil:InstanceExtendedAttribute[2]/@Value"/></span>
					</xsl:if>
					<xsl:if test="$act_id='NaN'">
						  <h1>Process History</h1>
						  <span class="tmdata"><b>Process Id : </b> <xsl:value-of select="xpil:InstanceExtendedAttributes/xpil:InstanceExtendedAttribute[1]/@Value"/></span>
					</xsl:if>
			</div>
			<xsl:variable name="cancelUrl">javascript:submitFormEvent('mainForm','HistoryHandlerPO.po?from=<xsl:value-of select='$from_element' />&#38;sortCriterion=<xsl:value-of select="$sortCriterion" />&#38;sortAsc=<xsl:value-of select="$sortAsc" />&#38;fromPage=<xsl:value-of select="$fromPage" />&#38;pro_id=<xsl:value-of select="/xpil:ExtendedWorkflowFacilityInstance/xpil:InstanceExtendedAttributes/xpil:InstanceExtendedAttribute[1]/@Value" />','cancel')</xsl:variable>
			<div class="cnttbw">
				<div class="toolbar">
					<div class="toolbarw0">
						<div class="toolbarw">
								<ul class="toollset toollsetsa">
									<li><a class="back" href="{$cancelUrl}" title="Back"><span></span></a></li>
								</ul>
						</div>
					</div>
				</div>
			</div>	
		</div>
	</div>
</div>
<!-- toolbar end -->
</div></div>
<!-- header end-->

<!-- frame -->
<div id="cntframew" >
<div id="cntframe"><div id="cnt01">
   
<table class="table01" id="prlistdata" cellspacing="0">
<thead id="table01head">
    <tr>
    	<th>Time</th>
		<th>Description</th>
	</tr>
</thead>

<tbody class="table01body">
<xsl:variable name="Attr1" select="//."/>
<xsl:for-each select="$Attr1[name()='xpil:StateEventAudit' or name()='xpil:DataEventAudit' or name()='xpil:AssignmentEventAudit'  or name()='xpil:CreateProcessEventAudit']">
	<xsl:variable name="oddEven">
		<xsl:choose>
			<xsl:when test="(position() mod 2) = 0">odd</xsl:when>
			<xsl:otherwise>even</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<tr class="{$oddEven}">			
		<td class="usualtable" style="width:4%">
			<xsl:value-of select="concat(substring(@Created,0,11),' ',substring(@Created,12,12))" />
		</td>
		<td>
			<b>Type:</b>
			<xsl:value-of
				select="@Type" />
			<b>  Package id:</b>
			<xsl:value-of
				select="@PackageId" />
			<b>  Process factory id:</b>
			<xsl:value-of
				select="@WorkflowProcessFactoryId" />
			<b>  Process factory version:</b>
			<xsl:value-of
				select="@WorkflowProcessFactoryVersion" />
			<b>  Process id:</b>
			<xsl:value-of
				select="@WorkflowProcessInstanceId" />
			<b>  Process name:</b>
			<xsl:value-of
				select="@WorkflowProcessInstanceName" />
				<b>  Process definition id:</b>
			<xsl:value-of
				select="@ProcessDefinitionId" />
			<xsl:if test="/xpil:ExtendedWorkflowFacilityInstance/xpil:InstanceExtendedAttributes/xpil:InstanceExtendedAttribute[2]/@Value!='NaN'" >
			<b>  Activity id:</b>
			<xsl:value-of
				select="@ActivityInstanceId" />
				<b>  Activity name:</b>
			<xsl:value-of
				select="@ActivityInstanceName" />
				<b>  Activity definition id:</b>
			<xsl:value-of
				select="@ActivityDefinitionId" />

			</xsl:if>
			<xsl:if test="name()='xpil:StateEventAudit'">
			<xsl:if test="@OldState!=''">
			 <b>  Old state:</b>
			<xsl:value-of
				select="@OldState" />
			</xsl:if>
				<b>  New state:</b>
			<xsl:value-of
				select="@NewState" />

			</xsl:if>
			<xsl:if test="name()='xpil:AssignmentEventAudit'">
			<xsl:if test="@OldResourceKey!=''">
			 <b>  Old resource key:</b>
			<xsl:value-of
				select="@OldResourceKey" />
				<b>  Old resource name:</b>
				<xsl:value-of
				select="@OldResourceName" />
			</xsl:if>
				<b>  New resource key:</b>
			<xsl:value-of
				select="@NewResourceKey" />
				<b>  New resource name:</b>
			<xsl:value-of
				select="@NewResourceName" />
				<b>  IS accepted:</b>
			<xsl:value-of
				select="@IsAccepted" />
			</xsl:if>
			<xsl:if test="name()='xpil:CreateProcessEventAudit'">
			<xsl:if test="@PWorkflowProcessInstanceId!=''">

			<b>PPackage id:</b>
			<xsl:value-of
				select="@PPackageId" />
			 <b>PProcess factory name:</b>
			<xsl:value-of
				select="@PWorkflowProcessFactoryId" />
			 <b>PProcess factory version:</b>
			<xsl:value-of
				select="@PWorkflowProcessFactoryVersion" />
				<b>PProcess id:</b>
			<xsl:value-of
				select="PWorkflowProcessInstanceId" />
				<b>PProcess name:</b>
			<xsl:value-of
				select="PWorkflowProcessInstanceName" />
				<b>PProcess definition id:</b>
			<xsl:value-of
				select="PProcessDefinitionId" />
				<b>PActivity id:</b>
			<xsl:value-of
				select="PActivityInstanceId" />
				<b>PActivity definition id:</b>
			<xsl:value-of
				select="PActivityDefinitionId" />		
			</xsl:if>
			</xsl:if>
		</td>
	</tr>
</xsl:for-each>
</tbody>
</table>

</div></div></div>
<!-- frame end -->    

<!-- footer -->
	<xsl:call-template name="Footer"></xsl:call-template>
<!-- footer end -->

</div></div>
<!-- page end -->

</div>

<script type="text/javascript">
//<![CDATA[

dynStyleSet(['tbodyFrame', 'thHighlight', 'tatdHighlight']);

//]]>
</script>

</form>
</body>
</html>
</xsl:template>
</xsl:stylesheet>