<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" exclude-result-prefixes="xpil" xmlns:prop="java.util.Properties" xmlns:xpil="http://www.together.at/2006/XPIL1.0" xmlns:xpdl="http://www.wfmc.org/2002/XPDL1.0" version="1.0">
<xsl:output method="html" />
<xsl:param name="auth_type" select="FORM" />
<xsl:param name="username" select="u" />
<xsl:param name="from_element" select="11" />
<xsl:param name="to_element" select="20" />
<xsl:param name="sortCriterion" select="20" />
<xsl:param name="sortAsc" select="true" />
<xsl:param name="total_number" select="200" />
<xsl:param name="sharkEdition" select="e" />
<xsl:param name="enableComments" select="e" />
<xsl:param name="selected_user" select="e" />
<xsl:param name="accessionMap" select="e" />
<xsl:param name="navig_url" select="ProcessMonitorHandlerPO.po" />

<xsl:include xmlns:xsl="http://www.w3.org/1999/XSL/Transform" href="navigation.xsl" />
<xsl:include xmlns:xsl="http://www.w3.org/1999/XSL/Transform" href="properties.xsl" />
<xsl:include xmlns:xsl="http://www.w3.org/1999/XSL/Transform" href="menu.xsl" />
<xsl:include xmlns:xsl="http://www.w3.org/1999/XSL/Transform" href="footer.xsl" />
<xsl:template match="xpil:ExtendedWorkflowFacilityInstance">

<html xmlns="http://www.w3.org/1999/xhtml">

<head>
<meta http-equiv="content-type" content="text/html; charset='UTF-8'"/>
<title>Process Monitor</title>
<link href="styles/style.css" rel="stylesheet" type="text/css" media="screen,projection,tv"/>
<link href="styles/style_ie.css" rel="stylesheet" type="text/css" media="screen,projection,tv"/>

<!--[if lte IE 6]>
<link href="styles/style_iel.css" rel="stylesheet" type="text/css" media="screen,projection,tv">
<![endif]-->
<!--[if gte IE 7]>
<link href="styles/style_ie.css" rel="stylesheet" type="text/css" media="screen,projection,tv">
<![endif]-->
<!--[if gte IE 8]>
<link href="styles/style_ien.css" rel="stylesheet" type="text/css" media="screen,projection,tv">
<![endif]-->
<script type="text/javascript" src="js/jslib.js"></script>
<script type="text/javascript" src="js/dynstyles.js"></script>
<script type="text/javascript" src="js/combobox.js"></script>

<script type="text/javascript" xmlns:prop="java.util.Properties" xmlns:xml="http://www.w3.org/XML/1998/namespace" xmlns:xpdl="http://www.wfmc.org/2002/XPDL1.0">
function submitForm(formId, actionAttr) { 
	var formTag = document.getElementById(formId);
	formTag.action=actionAttr; formTag.submit(); 
}

function submitFormEvent(formId, actionAttr,event) {
	var formTag = document.getElementById(formId);
	formTag.action=actionAttr;
	formTag.event.value=event; formTag.submit(); 
}

function openNewDialogWindow(pageName,windowName,parameters) {
	window.open(pageName,windowName,parameters); 
}

function submitContentFormWithAction(formId,actionAttr,event, txt) {
	if(confirm(txt)) {
		alreadySubmited = true;
		if(window.event != null)
        	window.event.returnValue = false;
        var formTag = document.getElementById(formId);
      	 formTag.action=actionAttr;
        formTag.event.value=event;
        formTag.submit();
    }
}
</script>
</head>
<body>
<form action="javascript: void 0" id="mainForm" method="post" name="mainForm">
<input name="event" type="hidden"/>
<xsl:variable name="rUrl">javascript:submitFormEvent('mainForm','ProcessMonitorHandlerPO.po?from=<xsl:value-of select="$from_element" />&#38;sortCriterion=<xsl:value-of select="$sortCriterion" />&#38;sortAsc=<xsl:value-of select="$sortAsc" />','refresh')</xsl:variable>
<xsl:variable name="tUrl">javascript:submitContentFormWithAction('mainForm','ProcessMonitorHandlerPO.po?from=<xsl:value-of select="$from_element" />&#38;sortCriterion=<xsl:value-of select="$sortCriterion" />&#38;sortAsc=<xsl:value-of select="$sortAsc" />&#38;page=ProcessMonitorHandlerPO.po','terminateAll','Do you really want to terminate all?')</xsl:variable>
<xsl:variable name="dUrl">javascript:submitContentFormWithAction('mainForm','ProcessMonitorHandlerPO.po?from=<xsl:value-of select="$from_element" />&#38;sortCriterion=<xsl:value-of select="$sortCriterion" />&#38;sortAsc=<xsl:value-of select="$sortAsc" />&#38;page=ProcessMonitorHandlerPO.po','deleteAll','Do you really want to delete all?')</xsl:variable>
<xsl:variable name="fdUrl">javascript:submitContentFormWithAction('mainForm','ProcessMonitorHandlerPO.po?from=<xsl:value-of select="$from_element" />&#38;sortCriterion=<xsl:value-of select="$sortCriterion" />&#38;sortAsc=<xsl:value-of select="$sortAsc" />','fastDelete','Do you really want to delete all?')</xsl:variable>
<xsl:variable name="revUrl">javascript:submitFormEvent('mainForm','ProcessMonitorHandlerPO.po?from=<xsl:value-of select="$from_element" />&#38;sortCriterion=<xsl:value-of select="$sortCriterion" />&#38;sortAsc=<xsl:value-of select="$sortAsc" />&#38;page=ProcessMonitorHandlerPO.po','revaluateAss')</xsl:variable>
<xsl:variable name="cUrl">javascript:submitFormEvent('mainForm','ProcessMonitorHandlerPO.po?from=<xsl:value-of select="$from_element" />&#38;sortCriterion=<xsl:value-of select="$sortCriterion" />&#38;sortAsc=<xsl:value-of select="$sortAsc" />&#38;page=ProcessMonitorHandlerPO.po','checkDl')</xsl:variable>
<xsl:variable name="lUrl">javascript:submitFormEvent('mainForm','ProcessMonitorHandlerPO.po?from=<xsl:value-of select="$from_element" />&#38;sortCriterion=<xsl:value-of select="$sortCriterion" />&#38;sortAsc=<xsl:value-of select="$sortAsc" />&#38;page=ProcessMonitorHandlerPO.po','checkLimit')</xsl:variable>

<div id="w0">

<!-- page -->
<div id="pw0"><div id="pw">

<!-- header -->
<div id="ph"><div id="phw">

<!-- header menu -->
	<xsl:call-template name="Menu">
		<xsl:with-param name="prop_repository" select="prop:getProperty('repository','true')" />
		<xsl:with-param name="prop_packagelist" select="prop:getProperty('packagelist','true')" />
		<xsl:with-param name="prop_processinst" select="prop:getProperty('processinst','true')" />
		<xsl:with-param name="prop_processmonitor" select="prop:getProperty('processmonitor','false')" />
		<xsl:with-param name="prop_usermanag" select="prop:getProperty('usermanag','true')" />
		<xsl:with-param name="prop_worklist" select="prop:getProperty('worklist','true')" />
		<xsl:with-param name="prop_processlist" select="prop:getProperty('processlist','true')" />
		<xsl:with-param name="prop_cache" select="prop:getProperty('cache','true')" />
		<xsl:with-param name="prop_application" select="prop:getProperty('application','true')" />
		<xsl:with-param name="prop_participant" select="prop:getProperty('participant','true')" />
		<xsl:with-param name="prop_groupmanag" select="prop:getProperty('groupmanag','true')" />
		<xsl:with-param name="sharkEdition" select="$sharkEdition"/>
	</xsl:call-template>
<!-- header menu end -->	
                    
<!-- toolbar -->
<div id="cnthdr">
	<div id="cnthdrw0">
		<div id="cnthdrw">
			<div class="h01">
				<h1>Process Monitor</h1>
				<span class="tmdata">
					<xsl:value-of select="$total_number"/> entries				
				</span>
			</div>
			<div align="left">
				<span align="left">
					<xsl:call-template name="Navigation"/>
				</span>
			</div>
			<div class="cnttbw">
				<div class="toolbar">
					<div class="toolbarw0">
						<div class="toolbarw">
							<ul class="toollset toollsetsa">
							<xsl:if test="$sharkEdition!='community'">
								<li><a class="terminateAllproc" href="{$tUrl}" title="Terminate All Processes"><span></span></a></li>
								<li><a class="deleteAllproc" href="{$dUrl}" title="Delete All Processes"><span></span></a></li>
								<li><a class="fastdeleteAllproc" href="{$fdUrl}" title="Fast delete All Processes"><span></span></a></li>
								<li><a class="reevaluateAss" href="{$revUrl}" title="Re-evaluate Assignments"><span></span></a></li>
								<li><a class="checkDead" href="{$cUrl}" title="Check Deadlines"><span></span></a></li>
								<li><a class="checkLimit" href="{$lUrl}" title="Check Limits"><span></span></a></li>
							</xsl:if>
								<li><a class="refresh" href="{$rUrl}" title="Refresh Process List"><span></span></a></li>
							</ul>
						</div>
					</div>
				</div>
			</div>	
		</div>
	</div>
</div>
<!-- toolbar end -->
</div></div>
<!-- header end-->

<!-- frame -->
<div id="cntframew"><div id="cntframe"><div id="cnt01">
   
<table class="table01" id="prlistdata" cellspacing="0">
<thead id="table01head">
    <tr>
     	<xsl:choose>
	      	<xsl:when test="$sortCriterion='id'">
	      		<xsl:choose>
	      			<xsl:when test="$sortAsc='true'">
		      			<th class="sortasc">
   							<xsl:variable name="url">javascript:submitFormEvent('mainForm','ProcessMonitorHandlerPO.po?from=<xsl:value-of select="$from_element" />&#38;sortCriterion=id&#38;sortAsc=<xsl:value-of select="not($sortAsc='true')" />','sort')</xsl:variable>
 			      			<a href="{$url}">Id</a>
			      		</th>	
			      	</xsl:when>
			      	<xsl:otherwise>
		      			<th class="sortdesc">
   							<xsl:variable name="url">javascript:submitFormEvent('mainForm','ProcessMonitorHandlerPO.po?from=<xsl:value-of select="$from_element" />&#38;sortCriterion=id&#38;sortAsc=<xsl:value-of select="not($sortAsc='true')" />','sort')</xsl:variable>
 			      			<a href="{$url}">Id</a>
			      		</th>	
			      	</xsl:otherwise>
			    </xsl:choose>	
			</xsl:when>
			<xsl:otherwise>
				<th class="sortable">
   					<xsl:variable name="url">javascript:submitFormEvent('mainForm','ProcessMonitorHandlerPO.po?from=<xsl:value-of select="$from_element" />&#38;sortCriterion=id&#38;sortAsc=<xsl:value-of select="not($sortAsc='true')" />','sort')</xsl:variable>
 			    	<a href="{$url}">Id</a>
			    </th>	
			</xsl:otherwise>
		</xsl:choose>
    
    	<xsl:choose>
	      	<xsl:when test="$sortCriterion='name'">
	      		<xsl:choose>
	      			<xsl:when test="$sortAsc='true'">
		      			<th class="sortasc">
							<xsl:variable name="url">javascript:submitFormEvent('mainForm','ProcessMonitorHandlerPO.po?from=<xsl:value-of select="$from_element" />&#38;sortCriterion=name&#38;sortAsc=<xsl:value-of select="not($sortAsc='true')" />','sort')</xsl:variable>
			      			<a href="{$url}">Name</a>
			      		</th>	
			      	</xsl:when>
			      	<xsl:otherwise>
		      			<th class="sortdesc">
							<xsl:variable name="url">javascript:submitFormEvent('mainForm','ProcessMonitorHandlerPO.po?from=<xsl:value-of select="$from_element" />&#38;sortCriterion=name&#38;sortAsc=<xsl:value-of select="not($sortAsc='true')" />','sort')</xsl:variable>
			      			<a href="{$url}">Name</a>
			      		</th>	
			      	</xsl:otherwise>
			    </xsl:choose>	
			</xsl:when>
			<xsl:otherwise>
				<th class="sortable">
					<xsl:variable name="url">javascript:submitFormEvent('mainForm','ProcessMonitorHandlerPO.po?from=<xsl:value-of select="$from_element" />&#38;sortCriterion=name&#38;sortAsc=<xsl:value-of select="not($sortAsc='true')" />','sort')</xsl:variable>
			    	<a href="{$url}">Name</a>
			    </th>	
			</xsl:otherwise>
		</xsl:choose>

     	<xsl:choose>
	      	<xsl:when test="$sortCriterion='requester'">
	      		<xsl:choose>
	      			<xsl:when test="$sortAsc='true'">
		      			<th class="sortasc">
							<xsl:variable name="url">javascript:submitFormEvent('mainForm','ProcessMonitorHandlerPO.po?from=<xsl:value-of select="$from_element" />&#38;sortCriterion=requester&#38;sortAsc=<xsl:value-of select="not($sortAsc='true')" />','sort')</xsl:variable>
			      			<a href="{$url}">Requester</a>
			      		</th>	
			      	</xsl:when>
			      	<xsl:otherwise>
		      			<th class="sortdesc">
							<xsl:variable name="url">javascript:submitFormEvent('mainForm','ProcessMonitorHandlerPO.po?from=<xsl:value-of select="$from_element" />&#38;sortCriterion=requester&#38;sortAsc=<xsl:value-of select="not($sortAsc='true')" />','sort')</xsl:variable>
			      			<a href="{$url}">Requester</a>
			      		</th>	
			      	</xsl:otherwise>
			    </xsl:choose>	
		    </xsl:when>
		    <xsl:otherwise>
      			<th class="sortable">
					<xsl:variable name="url">javascript:submitFormEvent('mainForm','ProcessMonitorHandlerPO.po?from=<xsl:value-of select="$from_element" />&#38;sortCriterion=requester&#38;sortAsc=<xsl:value-of select="not($sortAsc='true')" />','sort')</xsl:variable>
	      			<a href="{$url}">Requester</a>
	      		</th>	
		    </xsl:otherwise>
		</xsl:choose>
      
     	<xsl:choose>
	      	<xsl:when test="$sortCriterion='priority'">
	      		<xsl:choose>
	      			<xsl:when test="$sortAsc='true'">
		      			<th class="sortasc" style="width:3%">
							<xsl:variable name="url">javascript:submitFormEvent('mainForm','ProcessMonitorHandlerPO.po?from=<xsl:value-of select="$from_element" />&#38;sortCriterion=priority&#38;sortAsc=<xsl:value-of select="not($sortAsc='true')" />','sort')</xsl:variable>
			      			<a href="{$url}">Priority</a>
			      		</th>	
			      	</xsl:when>
			      	<xsl:otherwise>
		      			<th class="sortdesc" style="width:3%">
							<xsl:variable name="url">javascript:submitFormEvent('mainForm','ProcessMonitorHandlerPO.po?from=<xsl:value-of select="$from_element" />&#38;sortCriterion=priority&#38;sortAsc=<xsl:value-of select="not($sortAsc='true')" />','sort')</xsl:variable>
			      			<a href="{$url}">Priority</a>
			      		</th>	
			      	</xsl:otherwise>
			    </xsl:choose>	
			</xsl:when>
			<xsl:otherwise>
	   			<th class="sortable" style="width:3%">
					<xsl:variable name="url">javascript:submitFormEvent('mainForm','ProcessMonitorHandlerPO.po?from=<xsl:value-of select="$from_element" />&#38;sortCriterion=priority&#38;sortAsc=<xsl:value-of select="not($sortAsc='true')" />','sort')</xsl:variable>
					<a href="{$url}">Priority</a>
				</th>	
			</xsl:otherwise>    
		</xsl:choose>     
     
     	<xsl:choose>
	      	<xsl:when test="$sortCriterion='createdtime'">
	      		<xsl:choose>
	      			<xsl:when test="$sortAsc='true'">
		      			<th class="sortasc">
							<xsl:variable name="url">javascript:submitFormEvent('mainForm','ProcessMonitorHandlerPO.po?from=<xsl:value-of select="$from_element" />&#38;sortCriterion=createdtime&#38;sortAsc=<xsl:value-of select="not($sortAsc='true')" />','sort')</xsl:variable>
			      			<a href="{$url}">Created</a>
			      		</th>	
			      	</xsl:when>
			      	<xsl:otherwise>
		      			<th class="sortdesc">
							<xsl:variable name="url">javascript:submitFormEvent('mainForm','ProcessMonitorHandlerPO.po?from=<xsl:value-of select="$from_element" />&#38;sortCriterion=createdtime&#38;sortAsc=<xsl:value-of select="not($sortAsc='true')" />','sort')</xsl:variable>
			      			<a href="{$url}">Created</a>
			      		</th>	
			      	</xsl:otherwise>
			    </xsl:choose>	
			</xsl:when> 
			<xsl:otherwise>
	  			<th class="sortable">
					<xsl:variable name="url">javascript:submitFormEvent('mainForm','ProcessMonitorHandlerPO.po?from=<xsl:value-of select="$from_element" />&#38;sortCriterion=createdtime&#38;sortAsc=<xsl:value-of select="not($sortAsc='true')" />','sort')</xsl:variable>
	     			<a href="{$url}">Created</a>
	      		</th>	
			</xsl:otherwise>   
		</xsl:choose> 
	  <th>
      Finished
      </th>
    	<xsl:choose>
	      	<xsl:when test="$sortCriterion='state'">
	      		<xsl:choose>
	      			<xsl:when test="$sortAsc='true'">
		      			<th class="sortasc">
							<xsl:variable name="url">javascript:submitFormEvent('mainForm','ProcessMonitorHandlerPO.po?from=<xsl:value-of select="$from_element" />&#38;sortCriterion=state&#38;sortAsc=<xsl:value-of select="not($sortAsc='true')" />','sort')</xsl:variable>
			      			<a href="{$url}">State</a>
			      		</th>	
			      	</xsl:when>
			      	<xsl:otherwise>
		      			<th class="sortdesc">
							<xsl:variable name="url">javascript:submitFormEvent('mainForm','ProcessMonitorHandlerPO.po?from=<xsl:value-of select="$from_element" />&#38;sortCriterion=state&#38;sortAsc=<xsl:value-of select="not($sortAsc='true')" />','sort')</xsl:variable>
			      			<a href="{$url}">State</a>
			      		</th>	
			      	</xsl:otherwise>
			    </xsl:choose>	
			</xsl:when>
			<xsl:otherwise>
				<th class="sortable">
					<xsl:variable name="url">javascript:submitFormEvent('mainForm','ProcessMonitorHandlerPO.po?from=<xsl:value-of select="$from_element" />&#38;sortCriterion=state&#38;sortAsc=<xsl:value-of select="not($sortAsc='true')" />','sort')</xsl:variable>
		   			<a href="{$url}">State</a>
	      		</th>	
			</xsl:otherwise>
		</xsl:choose>    
    </tr>
</thead>

<tbody class="table01body">
<xsl:variable name="Attr1" select="//."/>
<xsl:for-each select="$Attr1[name()='xpil:MainWorkflowProcessInstance' or name()='xpil:SubWorkflowProcessInstance']">
	<xsl:variable name="oddEven">
		<xsl:choose>
			<xsl:when test="(position() mod 2) = 0">odd</xsl:when>
			<xsl:otherwise>even</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<tr class="{$oddEven}">			
		<td class="actcoltd">
			<div class="cntm">
				<div class="cntmw">
				    <ul class="cntmlist">
						<xsl:variable name="detailUrl">javascript:submitFormEvent('mainForm','ProcessMonitorHandlerPO.po?from=<xsl:value-of select="$from_element" />&#38;sortCriterion=<xsl:value-of select="$sortCriterion" />&#38;sortAsc=<xsl:value-of select="$sortAsc" />&#38;pro_id=<xsl:value-of select="@Id" />&#38;fromPage=ProcessMonitorHandlerPO.po&#38;readonly=true','details')</xsl:variable>
						<xsl:variable name="historyUrl">javascript:submitFormEvent('mainForm','ProcessMonitorHandlerPO.po?from=<xsl:value-of select="$from_element" />&#38;sortCriterion=<xsl:value-of select="$sortCriterion" />&#38;sortAsc=<xsl:value-of select="$sortAsc" />&#38;pro_id=<xsl:value-of select="@Id" />&#38;fromPage=ProcessMonitorHandlerPO.po&#38;readonly=true','history')</xsl:variable>
						<xsl:variable name="activitiesUrl">javascript:submitFormEvent('mainForm','ProcessMonitorHandlerPO.po?from=<xsl:value-of select="$from_element" />&#38;sortCriterion=<xsl:value-of select="$sortCriterion" />&#38;sortAsc=<xsl:value-of select="$sortAsc" />&#38;pro_id=<xsl:value-of select="@Id" />&#38;fromPage=ProcessMonitorHandlerPO.po','activities')</xsl:variable>
						<xsl:variable name="suspendUrl">javascript:submitContentFormWithAction('mainForm','ProcessMonitorHandlerPO.po?from=<xsl:value-of select="$from_element" />&#38;sortCriterion=<xsl:value-of select="$sortCriterion" />&#38;sortAsc=<xsl:value-of select="$sortAsc" />&#38;pro_id=<xsl:value-of select="@Id" />','suspend','Do you really want to suspend process?')</xsl:variable>
						<xsl:variable name="revalUrl">javascript:submitFormEvent('mainForm','ProcessMonitorHandlerPO.po?from=<xsl:value-of select="$from_element" />&#38;sortCriterion=<xsl:value-of select="$sortCriterion" />&#38;sortAsc=<xsl:value-of select="$sortAsc" />&#38;pro_id=<xsl:value-of select="@Id" />&#38;page=ProcessMonitorHandlerPO.po','revaluate')</xsl:variable>
						<xsl:variable name="checkUrl">javascript:submitFormEvent('mainForm','ProcessMonitorHandlerPO.po?from=<xsl:value-of select="$from_element" />&#38;sortCriterion=<xsl:value-of select="$sortCriterion" />&#38;sortAsc=<xsl:value-of select="$sortAsc" />&#38;pro_id=<xsl:value-of select="@Id" />&#38;page=ProcessMonitorHandlerPO.po','check')</xsl:variable>
						<xsl:variable name="limitUrl">javascript:submitFormEvent('mainForm','ProcessMonitorHandlerPO.po?from=<xsl:value-of select="$from_element" />&#38;sortCriterion=<xsl:value-of select="$sortCriterion" />&#38;sortAsc=<xsl:value-of select="$sortAsc" />&#38;pro_id=<xsl:value-of select="@Id" />&#38;page=ProcessMonitorHandlerPO.po','limit')</xsl:variable>
						<xsl:variable name="resumeUrl">javascript:submitFormEvent('mainForm','ProcessMonitorHandlerPO.po?from=<xsl:value-of select="$from_element" />&#38;sortCriterion=<xsl:value-of select="$sortCriterion" />&#38;sortAsc=<xsl:value-of select="$sortAsc" />&#38;pro_id=<xsl:value-of select="@Id" />','resume')</xsl:variable>
						<xsl:variable name="startUrl">javascript:submitFormEvent('mainForm','ProcessMonitorHandlerPO.po?from=<xsl:value-of select="$from_element" />&#38;sortCriterion=<xsl:value-of select="$sortCriterion" />&#38;sortAsc=<xsl:value-of select="$sortAsc" />&#38;pro_id=<xsl:value-of select="@Id" />','start')</xsl:variable>
						<xsl:variable name="terminateUrl">javascript:submitContentFormWithAction('mainForm','ProcessMonitorHandlerPO.po?from=<xsl:value-of select="$from_element" />&#38;sortCriterion=<xsl:value-of select="$sortCriterion" />&#38;sortAsc=<xsl:value-of select="$sortAsc" />&#38;pro_id=<xsl:value-of select="@Id" />','terminate','Do you really want to terminate process?')</xsl:variable>
						<xsl:variable name="deleteUrl">javascript:submitContentFormWithAction('mainForm','ProcessMonitorHandlerPO.po?from=<xsl:value-of select="$from_element" />&#38;sortCriterion=<xsl:value-of select="$sortCriterion" />&#38;sortAsc=<xsl:value-of select="$sortAsc" />&#38;pro_id=<xsl:value-of select="@Id" />','delete','Do you really want to delete process?')</xsl:variable>
						<xsl:variable name="migrateUrl">javascript:submitFormEvent('mainForm','ProcessMonitorHandlerPO.po?from=<xsl:value-of select="$from_element" />&#38;sortCriterion=<xsl:value-of select="$sortCriterion" />&#38;sortAsc=<xsl:value-of select="$sortAsc" />&#38;pro_id=<xsl:value-of select="@Id" />','migrate')</xsl:variable>
						<xsl:variable name="variablesUrl">javascript:submitFormEvent('mainForm','ProcessMonitorHandlerPO.po?from=<xsl:value-of select="$from_element" />&#38;sortCriterion=<xsl:value-of select="$sortCriterion" />&#38;sortAsc=<xsl:value-of select="$sortAsc" />&#38;pro_id=<xsl:value-of select="@Id" />&#38;fromPage=ProcessMonitorHandlerPO.po','variables')</xsl:variable>
						<xsl:variable name="allCommentsUrl">javascript:openNewDialogWindow('AllCommentsHandlerPO.po?pro_id=<xsl:value-of select="@Id" />','dialog','resizable=no,scrollbars=yes')</xsl:variable>
						<xsl:variable name="procGraphUrl">javascript:openNewDialogWindow('prof/ShowProcessGraphPO.po?pro_id=<xsl:value-of select="@Id" />','dialog2','width=800,height=600,resizable=yes,scrollbars=yes,left=300,top=200')</xsl:variable>
				      	<li><a class="procDet" href="{$detailUrl}"><span>Process Details</span></a></li>
						<xsl:if test="@State='open.not_running.not_started'">
							<li><a class="procStart" href="{$startUrl}"><span>Process Start</span></a></li>
						</xsl:if>
				      	<xsl:if test="@State='open.running'">
				      		<li><a class="procSusp" href="{$suspendUrl}"><span>Process Suspend</span></a></li>
				      	</xsl:if>	
						<xsl:if test="@State='open.not_running.suspended'">
							<li><a class="procRes" href="{$resumeUrl}"><span>Process Resume</span></a></li>
						</xsl:if>
						<xsl:if	test="not(starts-with(@State,'closed'))">
							<li><a class="procTerm" href="{$terminateUrl}"><span>Process Terminate</span></a></li>
						</xsl:if>
						<xsl:if test="starts-with(@State,'closed')">
							<li><a class="procDel" href="{$deleteUrl}"><span>Process Delete</span></a></li>
						</xsl:if>		
						<xsl:if test="not(starts-with(@State,'closed'))">
							<li><a class="procReev" href="{$revalUrl}"><span>Re-evaluate Assignments</span></a></li>
						</xsl:if>	
						<xsl:if test="@State='open.running'">
							<li><a class="procCheck" href="{$checkUrl}"><span>Check Deadlines</span></a></li>
							<li><a class="procLim" href="{$limitUrl}"><span>Check Limits</span></a></li>
						</xsl:if>		
						<xsl:if test="not(starts-with(@State,'closed')) and $sharkEdition!='community'">
							<li><a class="procMigr" href="{$migrateUrl}"><span>Process Migration</span></a></li>
						</xsl:if>	
							<li><a class="procAct" href="{$activitiesUrl}"><span>Process Activities</span></a></li>
							<li><a class="procVar" href="{$variablesUrl}"><span>Process Variables</span></a></li>
						<xsl:if test="$sharkEdition!='community'">
							<li><a class="procHis" href="{$historyUrl}"><span>Process History</span></a></li>
							<xsl:if test="$enableComments='true'">
								<li><a class="procComm" href="{$allCommentsUrl}"><span>Comments</span></a></li>
							</xsl:if>	
							<li><a class="prgraph" href="{$procGraphUrl}"><span>Process Execution Graph</span></a></li>
						</xsl:if>							
				    </ul>
				</div>
			</div>
			<a href="javascript: void(0)"><xsl:value-of select="@Id" /></a>			
		</td>	
		<td>
			<xsl:value-of select="@Name" />
		</td>
		<td>
			<xsl:value-of select="@RequesterUsername" />
		</td>
		<td style="width:3%;">
			<xsl:value-of select="xpil:InstancePriority" />
		</td>
		<td>
			<xsl:value-of select="concat(substring(@Created,0,11),' ',substring(@Created,12,5))" />
		</td>
		<xsl:choose>
			<xsl:when test="@State='open.running' or @State='open.not_running.suspended'">
				<td align="center"> - </td>
			</xsl:when>
			<xsl:otherwise>
				<td>
					<xsl:value-of select="concat(substring(@Finished,0,11),' ',substring(@Finished,12,5))" />
				</td>
			</xsl:otherwise>
		</xsl:choose>		
		<td>
			<xsl:value-of select="@State" />
		</td>
			
	</tr>
</xsl:for-each>
</tbody>
</table>

</div></div></div>
<!-- frame end -->    

<!-- footer -->
	<xsl:call-template name="Footer"></xsl:call-template>
<!-- footer end -->

</div></div>
<!-- page end -->

</div>

<script type="text/javascript">
//<![CDATA[

dynStyleSet(['tbodyFrame', 'thHighlight', 'tatdHighlight']);

//]]>
</script>

</form>
</body>
</html>
</xsl:template>
</xsl:stylesheet>