Create table SHKProcessHistoryInfo
(
ProcessId  VARCHAR (100)  NOT NULL     ,
ProcessName  VARCHAR (254)     ,
ProcessFactoryName  VARCHAR (200)  NOT NULL     ,
ProcessFactoryVersion  VARCHAR (20)  NOT NULL     ,
ProcessDefinitionId  VARCHAR (90)  NOT NULL     ,
ProcessDefinitionName  VARCHAR (90)     ,
ProcessPriority  INTEGER    ,
ProcessLimitTime  BIGINT    ,
ProcessDescription  VARCHAR (254)     ,
PackageId  VARCHAR (90)  NOT NULL     ,
PActivityId  VARCHAR (100)     ,
PProcessId  VARCHAR (100)     ,
PProcessName  VARCHAR (254)     ,
PProcessFactoryName  VARCHAR (200)     ,
PProcessFactoryVersion  VARCHAR (20)     ,
PActivityDefinitionId  VARCHAR (90)     ,
PActivityDefinitionName  VARCHAR (90)     ,
PProcessDefinitionId  VARCHAR (90)     ,
PProcessDefinitionName  VARCHAR (90)     ,
PPackageId  VARCHAR (90)     ,
CreatedTime  BIGINT    ,
CreatedTimeTZO  BIGINT    ,
StartedTime  BIGINT    ,
StartedTimeTZO  BIGINT    ,
SuspendedTime  BIGINT    ,
SuspendedTimeTZO  BIGINT    ,
ResumedTime  BIGINT    ,
ResumedTimeTZO  BIGINT    ,
ClosedTime  BIGINT    ,
ClosedTimeTZO  BIGINT    ,
DeletionTime  BIGINT    ,
DeletionTimeTZO  BIGINT    ,
CreatedByUsername  VARCHAR (100)     ,
StartedByUsername  VARCHAR (100)     ,
SuspendedByUsername  VARCHAR (100)     ,
ResumedByUsername  VARCHAR (100)     ,
ClosedByUsername  VARCHAR (100)     ,
DeletedByUsername  VARCHAR (100)     ,
LastState  VARCHAR (100)     ,
LastStateTime  BIGINT    ,
LastStateTimeTZO  BIGINT    ,
LastRecordedTime  BIGINT    ,
LastRecordedTimeTZO  BIGINT    ,
ProcessDuration  BIGINT    ,
IsDeleted  BOOLEAN    ,
ObjectId  DECIMAL (19,0)  NOT NULL     ,
ObjectVersion  INTEGER NOT NULL     
);



Create table SHKProcessHistoryDetails
(
ProcessId  VARCHAR (100)  NOT NULL     ,
ProcessHistoryInfo  DECIMAL (19,0)  NOT NULL    ,
TheType  INTEGER NOT NULL     ,
RecordedTime  BIGINT NOT NULL     ,
RecordedTimeTZO  BIGINT NOT NULL     ,
TheUsername  VARCHAR (100)  NOT NULL     ,
Priority  INTEGER    ,
LimitTime  BIGINT    ,
Description  VARCHAR (254)     ,
Name  VARCHAR (254)     ,
VariableDefinitionId  VARCHAR (100)     ,
VariableType  INTEGER    ,
VariableValue  BYTEA    ,
VariableValueXML  TEXT    ,
VariableValueVCHAR  VARCHAR (4000)     ,
VariableValueDBL  FLOAT8    ,
VariableValueLONG  BIGINT    ,
VariableValueDATE  TIMESTAMP    ,
VariableValueBOOL  BOOLEAN    ,
OrdNo  INTEGER NOT NULL     ,
CNT  DECIMAL (19,0)  NOT NULL     ,
ObjectId  DECIMAL (19,0)  NOT NULL     ,
ObjectVersion  INTEGER NOT NULL     
);



Create table SHKActivityHistoryInfo
(
ProcessId  VARCHAR (100)  NOT NULL     ,
ProcessName  VARCHAR (254)     ,
ProcessFactoryName  VARCHAR (200)  NOT NULL     ,
ProcessFactoryVersion  VARCHAR (20)  NOT NULL     ,
ProcessDefinitionId  VARCHAR (90)  NOT NULL     ,
ProcessDefinitionName  VARCHAR (90)     ,
ProcessPriority  INTEGER    ,
ProcessLimitTime  BIGINT    ,
ProcessDescription  VARCHAR (254)     ,
PackageId  VARCHAR (90)  NOT NULL     ,
ActivityId  VARCHAR (100)  NOT NULL     ,
ActivityName  VARCHAR (254)     ,
ActivityPriority  INTEGER    ,
ActivityLimitTime  BIGINT    ,
ActivityDescription  VARCHAR (254)     ,
ActivityDefinitionId  VARCHAR (90)  NOT NULL     ,
ActivityDefinitionName  VARCHAR (90)     ,
ActivityDefinitionType  INTEGER    ,
DeadlineTimeLimit  BIGINT    ,
DeadlineExceptionName  VARCHAR (100)     ,
DeadlineIsSynchronous  BOOLEAN    ,
CreatedTime  BIGINT NOT NULL     ,
CreatedTimeTZO  BIGINT    ,
StartedTime  BIGINT    ,
StartedTimeTZO  BIGINT    ,
SuspendedTime  BIGINT    ,
SuspendedTimeTZO  BIGINT    ,
ResumedTime  BIGINT    ,
ResumedTimeTZO  BIGINT    ,
AcceptedTime  BIGINT    ,
AcceptedTimeTZO  BIGINT    ,
RejectedTime  BIGINT    ,
RejectedTimeTZO  BIGINT    ,
ClosedTime  BIGINT    ,
ClosedTimeTZO  BIGINT    ,
DeletionTime  BIGINT    ,
DeletionTimeTZO  BIGINT    ,
CreatedByUsername  VARCHAR (100)     ,
StartedByUsername  VARCHAR (100)     ,
SuspendedByUsername  VARCHAR (100)     ,
ResumedByUsername  VARCHAR (100)     ,
AcceptedByUsername  VARCHAR (100)     ,
RejectedByUsername  VARCHAR (100)     ,
ClosedByUsername  VARCHAR (100)     ,
DeletedByUsername  VARCHAR (100)     ,
CurrentUsername  VARCHAR (100)     ,
LastState  VARCHAR (100)     ,
LastStateTime  BIGINT    ,
LastStateTimeTZO  BIGINT    ,
LastRecordedTime  BIGINT    ,
LastRecordedTimeTZO  BIGINT    ,
ActivityDuration  BIGINT    ,
IsDeleted  BOOLEAN    ,
ObjectId  DECIMAL (19,0)  NOT NULL     ,
ObjectVersion  INTEGER NOT NULL     
);



Create table SHKActivityHistoryDetails
(
ActivityId  VARCHAR (100)  NOT NULL     ,
ActivityHistoryInfo  DECIMAL (19,0)  NOT NULL    ,
TheType  INTEGER NOT NULL     ,
RecordedTime  BIGINT NOT NULL     ,
RecordedTimeTZO  BIGINT NOT NULL     ,
TheUsername  VARCHAR (100)  NOT NULL     ,
ReassignFrom  VARCHAR (100)     ,
ReassignTo  VARCHAR (100)     ,
Priority  INTEGER    ,
LimitTime  BIGINT    ,
Description  VARCHAR (254)     ,
Name  VARCHAR (254)     ,
DeadlineTimeLimit  BIGINT    ,
DeadlineExceptionName  VARCHAR (100)     ,
DeadlineIsSynchronous  BOOLEAN    ,
VariableDefinitionId  VARCHAR (100)     ,
VariableType  INTEGER    ,
VariableValue  BYTEA    ,
VariableValueXML  TEXT    ,
VariableValueVCHAR  VARCHAR (4000)     ,
VariableValueDBL  FLOAT8    ,
VariableValueLONG  BIGINT    ,
VariableValueDATE  TIMESTAMP    ,
VariableValueBOOL  BOOLEAN    ,
OrdNo  INTEGER NOT NULL     ,
CNT  DECIMAL (19,0)  NOT NULL     ,
ObjectId  DECIMAL (19,0)  NOT NULL     ,
ObjectVersion  INTEGER NOT NULL     
);



