--
-- PostgreSQL database dump
--

\connect - shark

SET search_path = public, pg_catalog;

--
-- TOC entry 2 (OID 523072)
-- Name: activities; Type: TABLE; Schema: public; Owner: shark
--

CREATE TABLE activities (
    id character varying(254) NOT NULL,
    activitydefinitionid character varying(254) NOT NULL,
    priority integer,
    name character varying(254),
    description text,
    process character varying(254) NOT NULL,
    blockactivity character varying(254),
    state numeric(19,0) NOT NULL,
    theresource character varying(25),
    activated bigint,
    accepted bigint,
    laststatetime bigint,
    iddb numeric(19,0) NOT NULL,
    activitysetdefinitionid character varying(254)
);


--
-- TOC entry 3 (OID 523074)
-- Name: andjointable; Type: TABLE; Schema: public; Owner: shark
--

CREATE TABLE andjointable (
    activitydefinitionid character varying(254) NOT NULL,
    process character varying(254) NOT NULL,
    activity character varying(254) NOT NULL,
    iddb numeric(19,0) NOT NULL,
    activitysetdefinitionid character varying(254)
);


--
-- TOC entry 4 (OID 523076)
-- Name: assignmentstable; Type: TABLE; Schema: public; Owner: shark
--

CREATE TABLE assignmentstable (
    activity character varying(254) NOT NULL,
    theresource character varying(25) NOT NULL,
    iddb numeric(19,0) NOT NULL
);


--
-- TOC entry 5 (OID 523078)
-- Name: assignmenteventaudits; Type: TABLE; Schema: public; Owner: shark
--

CREATE TABLE assignmenteventaudits (
    oldresourceusername character varying(25),
    oldresourcename character varying(254),
    newresourceusername character varying(25) NOT NULL,
    newresourcename character varying(254),
    isaccepted boolean NOT NULL,
    id numeric(19,0) NOT NULL
);


--
-- TOC entry 6 (OID 523080)
-- Name: createprocesseventaudits; Type: TABLE; Schema: public; Owner: shark
--

CREATE TABLE createprocesseventaudits (
    pactivityid character varying(254),
    pprocessid character varying(254),
    pprocessname character varying(254),
    pprocessdefinitionname character varying(254),
    pprocessdefinitionversion character varying(254),
    pactivitydefinitionid character varying(254),
    pprocessdefinitionid character varying(254),
    ppackageid character varying(254),
    id numeric(19,0) NOT NULL
);


--
-- TOC entry 7 (OID 523085)
-- Name: dataeventaudits; Type: TABLE; Schema: public; Owner: shark
--

CREATE TABLE dataeventaudits (
    id numeric(19,0) NOT NULL
);


--
-- TOC entry 8 (OID 523087)
-- Name: eventtypes; Type: TABLE; Schema: public; Owner: shark
--

CREATE TABLE eventtypes (
    keyvalue character varying(30) NOT NULL,
    name character varying(50) NOT NULL,
    iddb numeric(19,0) NOT NULL
);


--
-- TOC entry 9 (OID 523089)
-- Name: locktable; Type: TABLE; Schema: public; Owner: shark
--

CREATE TABLE locktable (
    enginename character varying(254) NOT NULL,
    id character varying(254) NOT NULL
);


--
-- TOC entry 10 (OID 523091)
-- Name: neweventauditdata; Type: TABLE; Schema: public; Owner: shark
--

CREATE TABLE neweventauditdata (
    dataeventaudit numeric(19,0) NOT NULL,
    variabledefinitionid character varying(254) NOT NULL,
    variablevalue bytea NOT NULL
);


--
-- TOC entry 11 (OID 523096)
-- Name: oldeventauditdata; Type: TABLE; Schema: public; Owner: shark
--

CREATE TABLE oldeventauditdata (
    dataeventaudit numeric(19,0) NOT NULL,
    variabledefinitionid character varying(254) NOT NULL,
    variablevalue bytea NOT NULL
);


--
-- TOC entry 12 (OID 523101)
-- Name: processes; Type: TABLE; Schema: public; Owner: shark
--

CREATE TABLE processes (
    id character varying(254) NOT NULL,
    priority integer,
    name character varying(254),
    description text,
    processdefinition character varying(254) NOT NULL,
    state numeric(19,0) NOT NULL,
    started bigint,
    laststatetime bigint,
    iddb numeric(19,0) NOT NULL
);


--
-- TOC entry 13 (OID 523103)
-- Name: processrequesters; Type: TABLE; Schema: public; Owner: shark
--

CREATE TABLE processrequesters (
    id character varying(254) NOT NULL,
    resourcerequester character varying(25),
    activityrequester character varying(254),
    iddb numeric(19,0) NOT NULL
);


--
-- TOC entry 14 (OID 523105)
-- Name: processdefinitions; Type: TABLE; Schema: public; Owner: shark
--

CREATE TABLE processdefinitions (
    name character varying(254) NOT NULL,
    packageid character varying(254) NOT NULL,
    processdefinitionid character varying(254) NOT NULL,
    processdefinitioncreated character varying(254) NOT NULL,
    processdefinitionversion character varying(254) NOT NULL,
    state integer NOT NULL,
    iddb numeric(19,0) NOT NULL
);


--
-- TOC entry 15 (OID 523107)
-- Name: resourcestable; Type: TABLE; Schema: public; Owner: shark
--

CREATE TABLE resourcestable (
    username character varying(25) NOT NULL,
    name character varying(50),
    iddb numeric(19,0) NOT NULL
);


--
-- TOC entry 16 (OID 523109)
-- Name: stateeventaudits; Type: TABLE; Schema: public; Owner: shark
--

CREATE TABLE stateeventaudits (
    id numeric(19,0) NOT NULL,
    oldstate character varying(254),
    newstate character varying(254) NOT NULL
);


--
-- TOC entry 17 (OID 523111)
-- Name: processdata; Type: TABLE; Schema: public; Owner: shark
--

CREATE TABLE processdata (
    variabledefinitionid character varying(254) NOT NULL,
    process character varying(254) NOT NULL,
    variablevalue bytea NOT NULL,
    iddb numeric(19,0) NOT NULL
);


--
-- TOC entry 18 (OID 523116)
-- Name: activitydata; Type: TABLE; Schema: public; Owner: shark
--

CREATE TABLE activitydata (
    variabledefinitionid character varying(254) NOT NULL,
    activity character varying(254) NOT NULL,
    variablevalue bytea NOT NULL,
    isresult boolean NOT NULL,
    iddb numeric(19,0) NOT NULL
);


--
-- TOC entry 19 (OID 523121)
-- Name: eventaudits; Type: TABLE; Schema: public; Owner: shark
--

CREATE TABLE eventaudits (
    utctime character varying(254) NOT NULL,
    activityid character varying(254),
    activityname character varying(254),
    processid character varying(254) NOT NULL,
    processname character varying(254) NOT NULL,
    processdefinitionname character varying(254) NOT NULL,
    processdefinitionversion character varying(254) NOT NULL,
    activitydefinitionid character varying(254),
    processdefinitionid character varying(254) NOT NULL,
    packageid character varying(254) NOT NULL,
    iddb numeric(19,0) NOT NULL,
    thetype numeric(19,0) NOT NULL
);


--
-- TOC entry 20 (OID 523126)
-- Name: activitystates; Type: TABLE; Schema: public; Owner: shark
--

CREATE TABLE activitystates (
    keyvalue character varying(30) NOT NULL,
    name character varying(50) NOT NULL,
    iddb numeric(19,0) NOT NULL
);


--
-- TOC entry 21 (OID 523128)
-- Name: grouptable; Type: TABLE; Schema: public; Owner: shark
--

CREATE TABLE grouptable (
    groupid character varying(254) NOT NULL,
    description character varying(254)
);


--
-- TOC entry 22 (OID 523130)
-- Name: processstates; Type: TABLE; Schema: public; Owner: shark
--

CREATE TABLE processstates (
    keyvalue character varying(30) NOT NULL,
    name character varying(50) NOT NULL,
    iddb numeric(19,0) NOT NULL
);


--
-- TOC entry 23 (OID 523132)
-- Name: usertable; Type: TABLE; Schema: public; Owner: shark
--

CREATE TABLE usertable (
    userid character varying(254) NOT NULL,
    passwd character varying(254) NOT NULL,
    email character varying(254),
    firstname character varying(254),
    lastname character varying(254)
);


--
-- TOC entry 24 (OID 523134)
-- Name: usergrouptable; Type: TABLE; Schema: public; Owner: shark
--

CREATE TABLE usergrouptable (
    userid character varying(254) NOT NULL,
    groupid character varying(254) NOT NULL
);


--
-- TOC entry 25 (OID 523136)
-- Name: counters; Type: TABLE; Schema: public; Owner: shark
--

CREATE TABLE counters (
    name character varying(254) NOT NULL,
    the_number numeric(19,0) NOT NULL
);


--
-- TOC entry 26 (OID 523138)
-- Name: applicationmappings; Type: TABLE; Schema: public; Owner: shark
--

CREATE TABLE applicationmappings (
    cnt numeric(19,0) NOT NULL,
    package_id character varying(100) NOT NULL,
    process_definition_id character varying(100),
    application_definition_id character varying(100) NOT NULL,
    tool_agent_name character varying(254) NOT NULL,
    username character varying(100),
    app_name character varying(254) NOT NULL,
    app_mode numeric(10,0),
    the_password character varying(100)
);


--
-- TOC entry 27 (OID 523140)
-- Name: groupgrouptable; Type: TABLE; Schema: public; Owner: shark
--

CREATE TABLE groupgrouptable (
    groupid character varying(254) NOT NULL,
    sub_gid character varying(254) NOT NULL
);


--
-- TOC entry 28 (OID 523142)
-- Name: package; Type: TABLE; Schema: public; Owner: shark
--

CREATE TABLE package (
    package_id character varying(100) NOT NULL
);


--
-- TOC entry 29 (OID 523144)
-- Name: process; Type: TABLE; Schema: public; Owner: shark
--

CREATE TABLE process (
    id numeric(19,0) NOT NULL,
    process_id character varying(100) NOT NULL,
    packageoid character varying(100) NOT NULL
);


--
-- TOC entry 30 (OID 523146)
-- Name: participant; Type: TABLE; Schema: public; Owner: shark
--

CREATE TABLE participant (
    id numeric(19,0) NOT NULL,
    participant_id character varying(100) NOT NULL
);


--
-- TOC entry 31 (OID 523148)
-- Name: packlevelparticipant; Type: TABLE; Schema: public; Owner: shark
--

CREATE TABLE packlevelparticipant (
    id numeric(19,0) NOT NULL,
    packageoid character varying(100) NOT NULL
);


--
-- TOC entry 32 (OID 523150)
-- Name: proclevelparticipant; Type: TABLE; Schema: public; Owner: shark
--

CREATE TABLE proclevelparticipant (
    id numeric(19,0) NOT NULL,
    processoid integer NOT NULL
);


--
-- TOC entry 33 (OID 523152)
-- Name: normaluser; Type: TABLE; Schema: public; Owner: shark
--

CREATE TABLE normaluser (
    username character varying(100) NOT NULL
);


--
-- TOC entry 34 (OID 523154)
-- Name: groupuser; Type: TABLE; Schema: public; Owner: shark
--

CREATE TABLE groupuser (
    username character varying(100) NOT NULL
);


--
-- TOC entry 35 (OID 523156)
-- Name: groupuserproclevelparticipant; Type: TABLE; Schema: public; Owner: shark
--

CREATE TABLE groupuserproclevelparticipant (
    participantoid numeric(19,0) NOT NULL,
    useroid character varying(100) NOT NULL
);


--
-- TOC entry 36 (OID 523158)
-- Name: groupuserpacklevelparticipant; Type: TABLE; Schema: public; Owner: shark
--

CREATE TABLE groupuserpacklevelparticipant (
    participantoid numeric(19,0) NOT NULL,
    useroid character varying(100) NOT NULL
);


--
-- TOC entry 37 (OID 523160)
-- Name: userproclevelparticipant; Type: TABLE; Schema: public; Owner: shark
--

CREATE TABLE userproclevelparticipant (
    participantoid numeric(19,0) NOT NULL,
    useroid character varying(100) NOT NULL
);


--
-- TOC entry 38 (OID 523162)
-- Name: userpacklevelparticipant; Type: TABLE; Schema: public; Owner: shark
--

CREATE TABLE userpacklevelparticipant (
    participantoid numeric(19,0) NOT NULL,
    useroid character varying(100) NOT NULL
);


--
-- TOC entry 39 (OID 523164)
-- Name: xpdls; Type: TABLE; Schema: public; Owner: shark
--

CREATE TABLE xpdls (
    xpdlid character varying(254) NOT NULL,
    xpdlversion character varying(20) NOT NULL,
    xpdlcontent bytea NOT NULL,
    id numeric(19,0) NOT NULL
);


--
-- TOC entry 40 (OID 523169)
-- Name: xpdlhistory; Type: TABLE; Schema: public; Owner: shark
--

CREATE TABLE xpdlhistory (
    xpdlid character varying(254) NOT NULL,
    xpdlversion character varying(20) NOT NULL,
    xpdlcontent bytea NOT NULL,
    id numeric(19,0) NOT NULL
);


--
-- TOC entry 41 (OID 523174)
-- Name: nextxpdlversions; Type: TABLE; Schema: public; Owner: shark
--

CREATE TABLE nextxpdlversions (
    id numeric(19,0) NOT NULL,
    xpdlid character varying(254) NOT NULL,
    nextversion character varying(20) NOT NULL
);


--
-- TOC entry 42 (OID 523176)
-- Name: activitystateeventaudits; Type: TABLE; Schema: public; Owner: shark
--

CREATE TABLE activitystateeventaudits (
    keyvalue character varying(30) NOT NULL,
    name character varying(50) NOT NULL,
    iddb numeric(19,0) NOT NULL
);


--
-- TOC entry 43 (OID 523178)
-- Name: deadlines; Type: TABLE; Schema: public; Owner: shark
--

CREATE TABLE deadlines (
    activity character varying(254) NOT NULL,
    timelimit bigint NOT NULL,
    exceptionname character varying(254) NOT NULL,
    process character varying(254) NOT NULL,
    iddb numeric(19,0) NOT NULL,
    issynchronous boolean NOT NULL
);


--
-- TOC entry 44 (OID 523180)
-- Name: processstateeventaudits; Type: TABLE; Schema: public; Owner: shark
--

CREATE TABLE processstateeventaudits (
    keyvalue character varying(30) NOT NULL,
    name character varying(50) NOT NULL,
    iddb numeric(19,0) NOT NULL
);


--
-- TOC entry 45 (OID 523182)
-- Name: xpdlreferences; Type: TABLE; Schema: public; Owner: shark
--

CREATE TABLE xpdlreferences (
    referredxpdlid character varying(254) NOT NULL,
    referringxpdl numeric(19,0) NOT NULL
);


--
-- TOC entry 47 (OID 523184)
-- Name: activities_i1; Type: INDEX; Schema: public; Owner: shark
--

CREATE UNIQUE INDEX activities_i1 ON activities USING btree (id);


--
-- TOC entry 64 (OID 523185)
-- Name: eventtypes_i1; Type: INDEX; Schema: public; Owner: shark
--

CREATE UNIQUE INDEX eventtypes_i1 ON eventtypes USING btree (keyvalue);


--
-- TOC entry 65 (OID 523186)
-- Name: eventtypes_i2; Type: INDEX; Schema: public; Owner: shark
--

CREATE UNIQUE INDEX eventtypes_i2 ON eventtypes USING btree (name);


--
-- TOC entry 67 (OID 523187)
-- Name: locktable_i1; Type: INDEX; Schema: public; Owner: shark
--

CREATE UNIQUE INDEX locktable_i1 ON locktable USING btree (id);


--
-- TOC entry 69 (OID 523188)
-- Name: neweventauditdata_i1; Type: INDEX; Schema: public; Owner: shark
--

CREATE UNIQUE INDEX neweventauditdata_i1 ON neweventauditdata USING btree (dataeventaudit, variabledefinitionid);


--
-- TOC entry 71 (OID 523189)
-- Name: oldeventauditdata_i1; Type: INDEX; Schema: public; Owner: shark
--

CREATE UNIQUE INDEX oldeventauditdata_i1 ON oldeventauditdata USING btree (dataeventaudit, variabledefinitionid);


--
-- TOC entry 73 (OID 523190)
-- Name: processes_i1; Type: INDEX; Schema: public; Owner: shark
--

CREATE UNIQUE INDEX processes_i1 ON processes USING btree (id);


--
-- TOC entry 82 (OID 523191)
-- Name: resourcestable_i1; Type: INDEX; Schema: public; Owner: shark
--

CREATE UNIQUE INDEX resourcestable_i1 ON resourcestable USING btree (username);


--
-- TOC entry 92 (OID 523192)
-- Name: activitystates_i1; Type: INDEX; Schema: public; Owner: shark
--

CREATE UNIQUE INDEX activitystates_i1 ON activitystates USING btree (keyvalue);


--
-- TOC entry 93 (OID 523193)
-- Name: activitystates_i2; Type: INDEX; Schema: public; Owner: shark
--

CREATE UNIQUE INDEX activitystates_i2 ON activitystates USING btree (name);


--
-- TOC entry 89 (OID 523194)
-- Name: activitydata_i1; Type: INDEX; Schema: public; Owner: shark
--

CREATE UNIQUE INDEX activitydata_i1 ON activitydata USING btree (activity, variabledefinitionid);


--
-- TOC entry 58 (OID 523196)
-- Name: assignmenteventaudits_i1; Type: INDEX; Schema: public; Owner: shark
--

CREATE UNIQUE INDEX assignmenteventaudits_i1 ON assignmenteventaudits USING btree (id);


--
-- TOC entry 60 (OID 523197)
-- Name: createprocesseventaudits_i1; Type: INDEX; Schema: public; Owner: shark
--

CREATE UNIQUE INDEX createprocesseventaudits_i1 ON createprocesseventaudits USING btree (id);


--
-- TOC entry 62 (OID 523198)
-- Name: dataeventaudits_i1; Type: INDEX; Schema: public; Owner: shark
--

CREATE UNIQUE INDEX dataeventaudits_i1 ON dataeventaudits USING btree (id);


--
-- TOC entry 95 (OID 523199)
-- Name: grouptable_i1; Type: INDEX; Schema: public; Owner: shark
--

CREATE UNIQUE INDEX grouptable_i1 ON grouptable USING btree (groupid);


--
-- TOC entry 86 (OID 523200)
-- Name: processdata_i1; Type: INDEX; Schema: public; Owner: shark
--

CREATE UNIQUE INDEX processdata_i1 ON processdata USING btree (process, variabledefinitionid);


--
-- TOC entry 80 (OID 523201)
-- Name: processdefinitions_i1; Type: INDEX; Schema: public; Owner: shark
--

CREATE UNIQUE INDEX processdefinitions_i1 ON processdefinitions USING btree (name);


--
-- TOC entry 97 (OID 523202)
-- Name: processstates_i1; Type: INDEX; Schema: public; Owner: shark
--

CREATE UNIQUE INDEX processstates_i1 ON processstates USING btree (keyvalue);


--
-- TOC entry 98 (OID 523203)
-- Name: processstates_i2; Type: INDEX; Schema: public; Owner: shark
--

CREATE UNIQUE INDEX processstates_i2 ON processstates USING btree (name);


--
-- TOC entry 100 (OID 523204)
-- Name: usertable_i1; Type: INDEX; Schema: public; Owner: shark
--

CREATE UNIQUE INDEX usertable_i1 ON usertable USING btree (userid);


--
-- TOC entry 102 (OID 523205)
-- Name: usergrouptable_i1; Type: INDEX; Schema: public; Owner: shark
--

CREATE UNIQUE INDEX usergrouptable_i1 ON usergrouptable USING btree (userid, groupid);


--
-- TOC entry 84 (OID 523206)
-- Name: stateeventaudits_i1; Type: INDEX; Schema: public; Owner: shark
--

CREATE UNIQUE INDEX stateeventaudits_i1 ON stateeventaudits USING btree (id);


--
-- TOC entry 53 (OID 523207)
-- Name: assignmentstable_i1; Type: INDEX; Schema: public; Owner: shark
--

CREATE UNIQUE INDEX assignmentstable_i1 ON assignmentstable USING btree (activity, theresource);


--
-- TOC entry 104 (OID 523208)
-- Name: i1_counters; Type: INDEX; Schema: public; Owner: shark
--

CREATE UNIQUE INDEX i1_counters ON counters USING btree (name);


--
-- TOC entry 106 (OID 523209)
-- Name: i1_applicationmappings; Type: INDEX; Schema: public; Owner: shark
--

CREATE UNIQUE INDEX i1_applicationmappings ON applicationmappings USING btree (cnt);


--
-- TOC entry 107 (OID 523210)
-- Name: i2_applicationmappings; Type: INDEX; Schema: public; Owner: shark
--

CREATE UNIQUE INDEX i2_applicationmappings ON applicationmappings USING btree (package_id, process_definition_id, application_definition_id);


--
-- TOC entry 109 (OID 523211)
-- Name: groupgrouptable_i1; Type: INDEX; Schema: public; Owner: shark
--

CREATE UNIQUE INDEX groupgrouptable_i1 ON groupgrouptable USING btree (sub_gid, groupid);


--
-- TOC entry 110 (OID 523212)
-- Name: groupgrouptable_i2; Type: INDEX; Schema: public; Owner: shark
--

CREATE INDEX groupgrouptable_i2 ON groupgrouptable USING btree (groupid);


--
-- TOC entry 141 (OID 523215)
-- Name: activitystateeventaudits_i1; Type: INDEX; Schema: public; Owner: shark
--

CREATE UNIQUE INDEX activitystateeventaudits_i1 ON activitystateeventaudits USING btree (keyvalue);


--
-- TOC entry 142 (OID 523216)
-- Name: activitystateeventaudits_i2; Type: INDEX; Schema: public; Owner: shark
--

CREATE UNIQUE INDEX activitystateeventaudits_i2 ON activitystateeventaudits USING btree (name);


--
-- TOC entry 125 (OID 523217)
-- Name: groupuser_i1; Type: INDEX; Schema: public; Owner: shark
--

CREATE UNIQUE INDEX groupuser_i1 ON groupuser USING btree (username);


--
-- TOC entry 117 (OID 523218)
-- Name: participant_i1; Type: INDEX; Schema: public; Owner: shark
--

CREATE UNIQUE INDEX participant_i1 ON participant USING btree (participant_id);


--
-- TOC entry 119 (OID 523219)
-- Name: packlevelparticipant_i1; Type: INDEX; Schema: public; Owner: shark
--

CREATE UNIQUE INDEX packlevelparticipant_i1 ON packlevelparticipant USING btree (id, packageoid);


--
-- TOC entry 112 (OID 523220)
-- Name: package_i1; Type: INDEX; Schema: public; Owner: shark
--

CREATE UNIQUE INDEX package_i1 ON package USING btree (package_id);


--
-- TOC entry 114 (OID 523221)
-- Name: process_i1; Type: INDEX; Schema: public; Owner: shark
--

CREATE UNIQUE INDEX process_i1 ON process USING btree (id);


--
-- TOC entry 115 (OID 523222)
-- Name: process_i2; Type: INDEX; Schema: public; Owner: shark
--

CREATE UNIQUE INDEX process_i2 ON process USING btree (process_id, packageoid);


--
-- TOC entry 121 (OID 523223)
-- Name: proclevelparticipant_i1; Type: INDEX; Schema: public; Owner: shark
--

CREATE UNIQUE INDEX proclevelparticipant_i1 ON proclevelparticipant USING btree (id, processoid);


--
-- TOC entry 129 (OID 523224)
-- Name: groupuserpacklevelparticipant_i1; Type: INDEX; Schema: public; Owner: shark
--

CREATE UNIQUE INDEX groupuserpacklevelparticipant_i1 ON groupuserpacklevelparticipant USING btree (participantoid, useroid);


--
-- TOC entry 127 (OID 523225)
-- Name: groupuserproclevelparticipant_i1; Type: INDEX; Schema: public; Owner: shark
--

CREATE UNIQUE INDEX groupuserproclevelparticipant_i1 ON groupuserproclevelparticipant USING btree (participantoid, useroid);


--
-- TOC entry 133 (OID 523226)
-- Name: userpacklevelparticipant_i1; Type: INDEX; Schema: public; Owner: shark
--

CREATE UNIQUE INDEX userpacklevelparticipant_i1 ON userpacklevelparticipant USING btree (participantoid, useroid);


--
-- TOC entry 123 (OID 523227)
-- Name: normaluser_i1; Type: INDEX; Schema: public; Owner: shark
--

CREATE UNIQUE INDEX normaluser_i1 ON normaluser USING btree (username);


--
-- TOC entry 131 (OID 523228)
-- Name: userproclevelparticipant_i1; Type: INDEX; Schema: public; Owner: shark
--

CREATE UNIQUE INDEX userproclevelparticipant_i1 ON userproclevelparticipant USING btree (participantoid, useroid);


--
-- TOC entry 147 (OID 523229)
-- Name: processstateeventaudits_i1; Type: INDEX; Schema: public; Owner: shark
--

CREATE UNIQUE INDEX processstateeventaudits_i1 ON processstateeventaudits USING btree (keyvalue);


--
-- TOC entry 148 (OID 523230)
-- Name: processstateeventaudits_i2; Type: INDEX; Schema: public; Owner: shark
--

CREATE UNIQUE INDEX processstateeventaudits_i2 ON processstateeventaudits USING btree (name);


--
-- TOC entry 137 (OID 523231)
-- Name: xpdlhistory_i1; Type: INDEX; Schema: public; Owner: shark
--

CREATE UNIQUE INDEX xpdlhistory_i1 ON xpdlhistory USING btree (xpdlid, xpdlversion);


--
-- TOC entry 135 (OID 523232)
-- Name: xpdls_i1; Type: INDEX; Schema: public; Owner: shark
--

CREATE UNIQUE INDEX xpdls_i1 ON xpdls USING btree (xpdlid, xpdlversion);


--
-- TOC entry 150 (OID 523233)
-- Name: i1_xpdlreferences; Type: INDEX; Schema: public; Owner: shark
--

CREATE UNIQUE INDEX i1_xpdlreferences ON xpdlreferences USING btree (referredxpdlid, referringxpdl);


--
-- TOC entry 139 (OID 523234)
-- Name: nextxpdlversions_i1; Type: INDEX; Schema: public; Owner: shark
--

CREATE UNIQUE INDEX nextxpdlversions_i1 ON nextxpdlversions USING btree (xpdlid, nextversion);


--
-- TOC entry 54 (OID 523235)
-- Name: assignmentstable_i2; Type: INDEX; Schema: public; Owner: shark
--

CREATE UNIQUE INDEX assignmentstable_i2 ON assignmentstable USING btree (iddb);


--
-- TOC entry 55 (OID 523236)
-- Name: assignmentstable_i3; Type: INDEX; Schema: public; Owner: shark
--

CREATE INDEX assignmentstable_i3 ON assignmentstable USING btree (activity);


--
-- TOC entry 56 (OID 523237)
-- Name: assignmentstable_i4; Type: INDEX; Schema: public; Owner: shark
--

CREATE INDEX assignmentstable_i4 ON assignmentstable USING btree (theresource);


--
-- TOC entry 74 (OID 523238)
-- Name: processes_i2; Type: INDEX; Schema: public; Owner: shark
--

CREATE INDEX processes_i2 ON processes USING btree (processdefinition);


--
-- TOC entry 76 (OID 523239)
-- Name: processrequesters_i1; Type: INDEX; Schema: public; Owner: shark
--

CREATE UNIQUE INDEX processrequesters_i1 ON processrequesters USING btree (id);


--
-- TOC entry 77 (OID 523240)
-- Name: processrequesters_i2; Type: INDEX; Schema: public; Owner: shark
--

CREATE INDEX processrequesters_i2 ON processrequesters USING btree (resourcerequester);


--
-- TOC entry 78 (OID 523241)
-- Name: processrequesters_i3; Type: INDEX; Schema: public; Owner: shark
--

CREATE INDEX processrequesters_i3 ON processrequesters USING btree (activityrequester);


--
-- TOC entry 87 (OID 523242)
-- Name: processdata_i2; Type: INDEX; Schema: public; Owner: shark
--

CREATE INDEX processdata_i2 ON processdata USING btree (process);


--
-- TOC entry 144 (OID 523243)
-- Name: deadlines_i1; Type: INDEX; Schema: public; Owner: shark
--

CREATE INDEX deadlines_i1 ON deadlines USING btree (activity);


--
-- TOC entry 145 (OID 523244)
-- Name: deadlines_i2; Type: INDEX; Schema: public; Owner: shark
--

CREATE INDEX deadlines_i2 ON deadlines USING btree (process);


--
-- TOC entry 48 (OID 523950)
-- Name: activities_i2; Type: INDEX; Schema: public; Owner: shark
--

CREATE INDEX activities_i2 ON activities USING btree (process);


--
-- TOC entry 49 (OID 523951)
-- Name: activities_i3; Type: INDEX; Schema: public; Owner: shark
--

CREATE INDEX activities_i3 ON activities USING btree (activitydefinitionid, process, activitysetdefinitionid);


--
-- TOC entry 51 (OID 523952)
-- Name: andjointable_i1; Type: INDEX; Schema: public; Owner: shark
--

CREATE INDEX andjointable_i1 ON andjointable USING btree (activitydefinitionid, process, activitysetdefinitionid);


--
-- TOC entry 155 (OID 523245)
-- Name: FK_AndJoinTable_Process; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY andjointable
    ADD CONSTRAINT "FK_AndJoinTable_Process" FOREIGN KEY (process) REFERENCES processes(id) ON UPDATE NO ACTION ON DELETE NO ACTION;


--
-- TOC entry 156 (OID 523249)
-- Name: FK_AndJoinTable_Activity; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY andjointable
    ADD CONSTRAINT "FK_AndJoinTable_Activity" FOREIGN KEY (activity) REFERENCES activities(id) ON UPDATE NO ACTION ON DELETE NO ACTION;


--
-- TOC entry 157 (OID 523253)
-- Name: FK_AssignmentsTable_Activity; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY assignmentstable
    ADD CONSTRAINT "FK_AssignmentsTable_Activity" FOREIGN KEY (activity) REFERENCES activities(id) ON UPDATE NO ACTION ON DELETE NO ACTION;


--
-- TOC entry 158 (OID 523257)
-- Name: FK_AssignmentsTable_Resource; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY assignmentstable
    ADD CONSTRAINT "FK_AssignmentsTable_Resource" FOREIGN KEY (theresource) REFERENCES resourcestable(username) ON UPDATE NO ACTION ON DELETE NO ACTION;


--
-- TOC entry 57 (OID 523261)
-- Name: PK_AssignmentEventAudits; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY assignmenteventaudits
    ADD CONSTRAINT "PK_AssignmentEventAudits" PRIMARY KEY (id);


--
-- TOC entry 59 (OID 523263)
-- Name: PK_CreateProcessEventAudits; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY createprocesseventaudits
    ADD CONSTRAINT "PK_CreateProcessEventAudits" PRIMARY KEY (id);


--
-- TOC entry 61 (OID 523265)
-- Name: PK_DataEventAudits; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY dataeventaudits
    ADD CONSTRAINT "PK_DataEventAudits" PRIMARY KEY (id);


--
-- TOC entry 160 (OID 523267)
-- Name: FK_OldEventAuditData_DataEventAudits; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY oldeventauditdata
    ADD CONSTRAINT "FK_OldEventAuditData_DataEventAudits" FOREIGN KEY (dataeventaudit) REFERENCES dataeventaudits(id) ON UPDATE NO ACTION ON DELETE NO ACTION;


--
-- TOC entry 159 (OID 523271)
-- Name: FK_NewEventAuditData_DataEventAudits; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY neweventauditdata
    ADD CONSTRAINT "FK_NewEventAuditData_DataEventAudits" FOREIGN KEY (dataeventaudit) REFERENCES dataeventaudits(id) ON UPDATE NO ACTION ON DELETE NO ACTION;


--
-- TOC entry 68 (OID 523275)
-- Name: PK_NewEventAuditData; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY neweventauditdata
    ADD CONSTRAINT "PK_NewEventAuditData" PRIMARY KEY (dataeventaudit, variabledefinitionid);


--
-- TOC entry 70 (OID 523277)
-- Name: PK_OldEventAuditData; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY oldeventauditdata
    ADD CONSTRAINT "PK_OldEventAuditData" PRIMARY KEY (dataeventaudit, variabledefinitionid);


--
-- TOC entry 83 (OID 523279)
-- Name: PK_StateEventAudits; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY stateeventaudits
    ADD CONSTRAINT "PK_StateEventAudits" PRIMARY KEY (id);


--
-- TOC entry 151 (OID 523281)
-- Name: FK_Activities_blockactivity_Activities; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY activities
    ADD CONSTRAINT "FK_Activities_blockactivity_Activities" FOREIGN KEY (blockactivity) REFERENCES activities(id) ON UPDATE NO ACTION ON DELETE NO ACTION;


--
-- TOC entry 152 (OID 523285)
-- Name: FK_Activities_Processes; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY activities
    ADD CONSTRAINT "FK_Activities_Processes" FOREIGN KEY (process) REFERENCES processes(id) ON UPDATE NO ACTION ON DELETE NO ACTION;


--
-- TOC entry 153 (OID 523289)
-- Name: FK_Activities_ResourceTable; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY activities
    ADD CONSTRAINT "FK_Activities_ResourceTable" FOREIGN KEY (theresource) REFERENCES resourcestable(username) ON UPDATE NO ACTION ON DELETE NO ACTION;


--
-- TOC entry 166 (OID 523293)
-- Name: FK_ActivityData_Activities; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY activitydata
    ADD CONSTRAINT "FK_ActivityData_Activities" FOREIGN KEY (activity) REFERENCES activities(id) ON UPDATE NO ACTION ON DELETE NO ACTION;


--
-- TOC entry 94 (OID 523297)
-- Name: PK_GroupTable; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY grouptable
    ADD CONSTRAINT "PK_GroupTable" PRIMARY KEY (groupid);


--
-- TOC entry 66 (OID 523299)
-- Name: PK_LockTable; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY locktable
    ADD CONSTRAINT "PK_LockTable" PRIMARY KEY (id);


--
-- TOC entry 165 (OID 523301)
-- Name: FK_ProcessData_Processes; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY processdata
    ADD CONSTRAINT "FK_ProcessData_Processes" FOREIGN KEY (process) REFERENCES processes(id) ON UPDATE NO ACTION ON DELETE NO ACTION;


--
-- TOC entry 161 (OID 523305)
-- Name: FK_Processes_ProcessDefinition; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY processes
    ADD CONSTRAINT "FK_Processes_ProcessDefinition" FOREIGN KEY (processdefinition) REFERENCES processdefinitions(name) ON UPDATE NO ACTION ON DELETE NO ACTION;


--
-- TOC entry 99 (OID 523309)
-- Name: PK_UserTable; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY usertable
    ADD CONSTRAINT "PK_UserTable" PRIMARY KEY (userid);


--
-- TOC entry 101 (OID 523311)
-- Name: PK_UserGroupTable; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY usergrouptable
    ADD CONSTRAINT "PK_UserGroupTable" PRIMARY KEY (userid, groupid);


--
-- TOC entry 168 (OID 523313)
-- Name: FK_UserGroupTable_gid_GroupTable; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY usergrouptable
    ADD CONSTRAINT "FK_UserGroupTable_gid_GroupTable" FOREIGN KEY (groupid) REFERENCES grouptable(groupid) ON UPDATE NO ACTION ON DELETE NO ACTION;


--
-- TOC entry 169 (OID 523317)
-- Name: FK_UserGroupTable_uid_UserTable; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY usergrouptable
    ADD CONSTRAINT "FK_UserGroupTable_uid_UserTable" FOREIGN KEY (userid) REFERENCES usertable(userid) ON UPDATE NO ACTION ON DELETE NO ACTION;


--
-- TOC entry 103 (OID 523321)
-- Name: PK_Counters; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY counters
    ADD CONSTRAINT "PK_Counters" PRIMARY KEY (name);


--
-- TOC entry 105 (OID 523323)
-- Name: PK_ApplicationMappings; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY applicationmappings
    ADD CONSTRAINT "PK_ApplicationMappings" PRIMARY KEY (cnt);


--
-- TOC entry 108 (OID 523325)
-- Name: Pk_GroupGroupTable; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY groupgrouptable
    ADD CONSTRAINT "Pk_GroupGroupTable" PRIMARY KEY (sub_gid, groupid);


--
-- TOC entry 170 (OID 523327)
-- Name: FK_GroupGroupTable_subgid_GroupTable; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY groupgrouptable
    ADD CONSTRAINT "FK_GroupGroupTable_subgid_GroupTable" FOREIGN KEY (sub_gid) REFERENCES grouptable(groupid) ON UPDATE NO ACTION ON DELETE NO ACTION;


--
-- TOC entry 183 (OID 523331)
-- Name: FK_Deadlines_Activity; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY deadlines
    ADD CONSTRAINT "FK_Deadlines_Activity" FOREIGN KEY (activity) REFERENCES activities(id) ON UPDATE NO ACTION ON DELETE NO ACTION;


--
-- TOC entry 171 (OID 523335)
-- Name: FK_GroupGroupTable_groupid_GroupTable; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY groupgrouptable
    ADD CONSTRAINT "FK_GroupGroupTable_groupid_GroupTable" FOREIGN KEY (groupid) REFERENCES grouptable(groupid) ON UPDATE NO ACTION ON DELETE NO ACTION;


--
-- TOC entry 124 (OID 523339)
-- Name: PK_GroupUser; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY groupuser
    ADD CONSTRAINT "PK_GroupUser" PRIMARY KEY (username);


--
-- TOC entry 128 (OID 523341)
-- Name: PK_Groupuserpacklevelparticipant; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY groupuserpacklevelparticipant
    ADD CONSTRAINT "PK_Groupuserpacklevelparticipant" PRIMARY KEY (participantoid, useroid);


--
-- TOC entry 116 (OID 523343)
-- Name: PK_Participant; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY participant
    ADD CONSTRAINT "PK_Participant" PRIMARY KEY (id);


--
-- TOC entry 120 (OID 523345)
-- Name: PK_Proclevelparticipant; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY proclevelparticipant
    ADD CONSTRAINT "PK_Proclevelparticipant" PRIMARY KEY (id);


--
-- TOC entry 111 (OID 523347)
-- Name: PK_Package; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY package
    ADD CONSTRAINT "PK_Package" PRIMARY KEY (package_id);


--
-- TOC entry 113 (OID 523349)
-- Name: PK_Process; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY process
    ADD CONSTRAINT "PK_Process" PRIMARY KEY (id);


--
-- TOC entry 172 (OID 523351)
-- Name: PK_Process_Package; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY process
    ADD CONSTRAINT "PK_Process_Package" FOREIGN KEY (packageoid) REFERENCES package(package_id) ON UPDATE NO ACTION ON DELETE NO ACTION;


--
-- TOC entry 173 (OID 523355)
-- Name: FK_Packlevelparticipant_Package; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY packlevelparticipant
    ADD CONSTRAINT "FK_Packlevelparticipant_Package" FOREIGN KEY (packageoid) REFERENCES package(package_id) ON UPDATE NO ACTION ON DELETE NO ACTION;


--
-- TOC entry 174 (OID 523359)
-- Name: FK_Proclevelparticipant_Process; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY proclevelparticipant
    ADD CONSTRAINT "FK_Proclevelparticipant_Process" FOREIGN KEY (processoid) REFERENCES process(id) ON UPDATE NO ACTION ON DELETE NO ACTION;


--
-- TOC entry 177 (OID 523363)
-- Name: FK_Groupuserpacklevelparticipant_Groupuser; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY groupuserpacklevelparticipant
    ADD CONSTRAINT "FK_Groupuserpacklevelparticipant_Groupuser" FOREIGN KEY (useroid) REFERENCES groupuser(username) ON UPDATE NO ACTION ON DELETE NO ACTION;


--
-- TOC entry 118 (OID 523367)
-- Name: PK_PackLevelParticipant; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY packlevelparticipant
    ADD CONSTRAINT "PK_PackLevelParticipant" PRIMARY KEY (id);


--
-- TOC entry 178 (OID 523369)
-- Name: FK_Groupuserpacklevelparticipant_Packlevelparticipant; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY groupuserpacklevelparticipant
    ADD CONSTRAINT "FK_Groupuserpacklevelparticipant_Packlevelparticipant" FOREIGN KEY (participantoid) REFERENCES packlevelparticipant(id) ON UPDATE NO ACTION ON DELETE NO ACTION;


--
-- TOC entry 126 (OID 523373)
-- Name: PK_Groupuserproclevelparticipant; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY groupuserproclevelparticipant
    ADD CONSTRAINT "PK_Groupuserproclevelparticipant" PRIMARY KEY (participantoid, useroid);


--
-- TOC entry 175 (OID 523375)
-- Name: FK_Groupuserproclevelparticipant_Groupuser; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY groupuserproclevelparticipant
    ADD CONSTRAINT "FK_Groupuserproclevelparticipant_Groupuser" FOREIGN KEY (useroid) REFERENCES groupuser(username) ON UPDATE NO ACTION ON DELETE NO ACTION;


--
-- TOC entry 176 (OID 523379)
-- Name: FK_Groupuserproclevelparticipant_ProcLevelParticipant; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY groupuserproclevelparticipant
    ADD CONSTRAINT "FK_Groupuserproclevelparticipant_ProcLevelParticipant" FOREIGN KEY (participantoid) REFERENCES proclevelparticipant(id) ON UPDATE NO ACTION ON DELETE NO ACTION;


--
-- TOC entry 132 (OID 523383)
-- Name: PK_Userpacklevelparticipant; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY userpacklevelparticipant
    ADD CONSTRAINT "PK_Userpacklevelparticipant" PRIMARY KEY (participantoid, useroid);


--
-- TOC entry 122 (OID 523385)
-- Name: PK_Normaluser; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY normaluser
    ADD CONSTRAINT "PK_Normaluser" PRIMARY KEY (username);


--
-- TOC entry 181 (OID 523387)
-- Name: FK_Userpacklevelparticipant_NormalUser; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY userpacklevelparticipant
    ADD CONSTRAINT "FK_Userpacklevelparticipant_NormalUser" FOREIGN KEY (useroid) REFERENCES normaluser(username) ON UPDATE NO ACTION ON DELETE NO ACTION;


--
-- TOC entry 182 (OID 523391)
-- Name: FK_Userpacklevelparticipant_PackLevelParticipant; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY userpacklevelparticipant
    ADD CONSTRAINT "FK_Userpacklevelparticipant_PackLevelParticipant" FOREIGN KEY (participantoid) REFERENCES packlevelparticipant(id) ON UPDATE NO ACTION ON DELETE NO ACTION;


--
-- TOC entry 130 (OID 523395)
-- Name: PK_Userproclevelparticipant; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY userproclevelparticipant
    ADD CONSTRAINT "PK_Userproclevelparticipant" PRIMARY KEY (participantoid, useroid);


--
-- TOC entry 179 (OID 523397)
-- Name: FK_Userproclevelparticipant_Normaluser; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY userproclevelparticipant
    ADD CONSTRAINT "FK_Userproclevelparticipant_Normaluser" FOREIGN KEY (useroid) REFERENCES normaluser(username) ON UPDATE NO ACTION ON DELETE NO ACTION;


--
-- TOC entry 180 (OID 523401)
-- Name: FK_Userproclevelparticipant_ProcLevelParticipant; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY userproclevelparticipant
    ADD CONSTRAINT "FK_Userproclevelparticipant_ProcLevelParticipant" FOREIGN KEY (participantoid) REFERENCES proclevelparticipant(id) ON UPDATE NO ACTION ON DELETE NO ACTION;


--
-- TOC entry 138 (OID 523405)
-- Name: PK_Nextxpdlversions; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY nextxpdlversions
    ADD CONSTRAINT "PK_Nextxpdlversions" PRIMARY KEY (id);


--
-- TOC entry 149 (OID 523407)
-- Name: PK_Xpdlreferences; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY xpdlreferences
    ADD CONSTRAINT "PK_Xpdlreferences" PRIMARY KEY (referredxpdlid, referringxpdl);


--
-- TOC entry 134 (OID 523409)
-- Name: PK_Xpdls; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY xpdls
    ADD CONSTRAINT "PK_Xpdls" PRIMARY KEY (id);


--
-- TOC entry 185 (OID 523411)
-- Name: FK_Xpdlreferences_Xpdls; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY xpdlreferences
    ADD CONSTRAINT "FK_Xpdlreferences_Xpdls" FOREIGN KEY (referringxpdl) REFERENCES xpdls(id) ON UPDATE NO ACTION ON DELETE NO ACTION;


--
-- TOC entry 136 (OID 523415)
-- Name: PK_Xpdlhistory; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY xpdlhistory
    ADD CONSTRAINT "PK_Xpdlhistory" PRIMARY KEY (id);


--
-- TOC entry 163 (OID 523417)
-- Name: PK_Processrequesters_Resource; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY processrequesters
    ADD CONSTRAINT "PK_Processrequesters_Resource" FOREIGN KEY (resourcerequester) REFERENCES resourcestable(username) ON UPDATE NO ACTION ON DELETE NO ACTION;


--
-- TOC entry 164 (OID 523421)
-- Name: PK_Processrequesters_Activity; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY processrequesters
    ADD CONSTRAINT "PK_Processrequesters_Activity" FOREIGN KEY (activityrequester) REFERENCES activities(id) ON UPDATE NO ACTION ON DELETE NO ACTION;


--
-- TOC entry 46 (OID 523425)
-- Name: PK_Activities; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY activities
    ADD CONSTRAINT "PK_Activities" PRIMARY KEY (iddb);


--
-- TOC entry 88 (OID 523427)
-- Name: PK_ActivityData; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY activitydata
    ADD CONSTRAINT "PK_ActivityData" PRIMARY KEY (iddb);


--
-- TOC entry 50 (OID 523429)
-- Name: PK_AndJoinTable; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY andjointable
    ADD CONSTRAINT "PK_AndJoinTable" PRIMARY KEY (iddb);


--
-- TOC entry 52 (OID 523431)
-- Name: PK_AssignmentsTable; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY assignmentstable
    ADD CONSTRAINT "PK_AssignmentsTable" PRIMARY KEY (iddb);


--
-- TOC entry 79 (OID 523433)
-- Name: PK_ProcessDefinitions; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY processdefinitions
    ADD CONSTRAINT "PK_ProcessDefinitions" PRIMARY KEY (iddb);


--
-- TOC entry 85 (OID 523435)
-- Name: PK_ProcessData; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY processdata
    ADD CONSTRAINT "PK_ProcessData" PRIMARY KEY (iddb);


--
-- TOC entry 91 (OID 523437)
-- Name: PK_ActivityStates; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY activitystates
    ADD CONSTRAINT "PK_ActivityStates" PRIMARY KEY (iddb);


--
-- TOC entry 154 (OID 523439)
-- Name: FK_Activities_ActivityStates; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY activities
    ADD CONSTRAINT "FK_Activities_ActivityStates" FOREIGN KEY (state) REFERENCES activitystates(iddb) ON UPDATE NO ACTION ON DELETE NO ACTION;


--
-- TOC entry 96 (OID 523443)
-- Name: PK_ProcessStates; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY processstates
    ADD CONSTRAINT "PK_ProcessStates" PRIMARY KEY (iddb);


--
-- TOC entry 162 (OID 523445)
-- Name: FK_Processes_ProcessStates; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY processes
    ADD CONSTRAINT "FK_Processes_ProcessStates" FOREIGN KEY (state) REFERENCES processstates(iddb) ON UPDATE NO ACTION ON DELETE NO ACTION;


--
-- TOC entry 90 (OID 523449)
-- Name: PK_EventAudits; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY eventaudits
    ADD CONSTRAINT "PK_EventAudits" PRIMARY KEY (iddb);


--
-- TOC entry 81 (OID 523451)
-- Name: PK_ResourceTable; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY resourcestable
    ADD CONSTRAINT "PK_ResourceTable" PRIMARY KEY (iddb);


--
-- TOC entry 63 (OID 523453)
-- Name: PK_EventTypes; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY eventtypes
    ADD CONSTRAINT "PK_EventTypes" PRIMARY KEY (iddb);


--
-- TOC entry 72 (OID 523455)
-- Name: PK_Processes; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY processes
    ADD CONSTRAINT "PK_Processes" PRIMARY KEY (iddb);


--
-- TOC entry 75 (OID 523457)
-- Name: PK_ProcessRequesters; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY processrequesters
    ADD CONSTRAINT "PK_ProcessRequesters" PRIMARY KEY (iddb);


--
-- TOC entry 140 (OID 523459)
-- Name: PK_ActivityStateEventAudits; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY activitystateeventaudits
    ADD CONSTRAINT "PK_ActivityStateEventAudits" PRIMARY KEY (iddb);


--
-- TOC entry 146 (OID 523461)
-- Name: PK_ProcessStateEventAudits; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY processstateeventaudits
    ADD CONSTRAINT "PK_ProcessStateEventAudits" PRIMARY KEY (iddb);


--
-- TOC entry 143 (OID 523463)
-- Name: PK_Deadlines; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY deadlines
    ADD CONSTRAINT "PK_Deadlines" PRIMARY KEY (iddb);


--
-- TOC entry 184 (OID 523465)
-- Name: FK_Deadlines_Process; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY deadlines
    ADD CONSTRAINT "FK_Deadlines_Process" FOREIGN KEY (process) REFERENCES processes(id) ON UPDATE NO ACTION ON DELETE NO ACTION;


--
-- TOC entry 167 (OID 523469)
-- Name: FK_EventAudits_EventTypes; Type: CONSTRAINT; Schema: public; Owner: shark
--

ALTER TABLE ONLY eventaudits
    ADD CONSTRAINT "FK_EventAudits_EventTypes" FOREIGN KEY (thetype) REFERENCES eventtypes(iddb) ON UPDATE NO ACTION ON DELETE NO ACTION;


